-- @description Region chord editor
-- @version 1.04
-- @author MPL
-- @website http://forum.cockos.com/showthread.php?t=165672
-- @changelog
--    + use existed regions color map, otherwise on cropping current region use previous color
--    # disable text wrap
--    # set edit cursor to start of newly added region
--    # dark/ignore regions contain @ character


  local vrs = 'v1.04'
  --NOT gfx NOT reaper
  --Modified for ReatRak
    function Msg(variable)
      reaper.ShowConsoleMsg(tostring(variable).."\n")
    end
    
-- Returns current script's path
function get_script_path()
  local info = debug.getinfo(1,'S');
  local script_path = info.source:match[[^@?(.*[\/])[^\/]-$]]
  return script_path
end

-- Get "script path"
local script_path = get_script_path()
--msg(script_path)

  -- Modify "package.path"
  package.path = package.path .. ";" .. script_path .. "?.lua"
  --msg(package.path)
  
            
  ---------------------------------------------
  -- Import files ("classes", functions etc.)--
  ---------------------------------------------
  require "ReaTrak rc class" -- import "base class"
  --local mouse = require "mouse"
  local Menu = require "ReaTrak rc menu class"
  --------------------------------------------- 
 
  
  --  INIT -------------------------------------------------
  local conf = {}  
  local refresh = { GUI_onStart = true, 
                    GUI = false, 
                    GUI_minor = false,
                    data = false,
                    data_proj = false, 
                    conf = false}
  local mouse = {}
  local data = {}
  local obj = {}
  
  local info = debug.getinfo(1,'S');  
  local script_path = info.source:match([[^@?(.*[\/])[^\/]-$]]) 
  obj.script_path = script_path 
  obj.GUI_font = 'Calibri' --'chords'
  chord_font_size = 29
  chord_length = 0
  
  cur_pos = reaper.GetCursorPosition()
  --commandID3 = reaper.NamedCommandLookup("_RS558f5cec5230ef6366aae51c5f9138909bd8a01d")
  --reaper.Main_OnCommand(commandID3, 0) -- Script: ReaTrak select current region.lua
  reaper.Main_OnCommand(40042,0) -- Transport: Go to start of project
  
  start_pos = reaper.GetCursorPosition()
  buf = reaper.format_timestr_pos(start_pos, "", -1)
  if buf == "-1.1.00" then bar_offset = -1 
  elseif buf == "-2.1.00" then bar_offset = -2 
  elseif buf == "-3.1.00" then bar_offset = -3 
     else bar_offset = 1 end
  reaper.SetEditCurPos(cur_pos, 1, 0)
--Msg("Start= "..buf)
--Msg("Bar offset= "..bar_offset)  
 
 -- Create a "Menu" instance
  rc_menu = Menu("rc_menu")
 
 -- Add menu items to "rc_menu"
 
--  > at the start of label: spawn a submenu
--  < at the start of label: last item in a submenu
--  <> or >< should work also
--  | at the end of label: adds a separator
 
 
 -- Top level items
item1 = rc_menu:add_item({label = "Remove Region Chord"})
item2 = rc_menu:add_item({label = "Merge to Next Region"})          
item3 = rc_menu:add_item({label = "Merge to Previous Region"})
  item100 = rc_menu:add_item({label = ">Set Song Part"})
  item4 = rc_menu:add_item({label = "Count-in"})                   
      
  item105 = rc_menu:add_item({label = ">Verse"})                   
    item5 = rc_menu:add_item({label = "Verse"})
    item6 = rc_menu:add_item({label = "Verse Post Fill"})           
    item7 = rc_menu:add_item({label = "<Verse Fill"})  
  
  item110 = rc_menu:add_item({label = ">Chorus"})
    item8 = rc_menu:add_item({label = "Chorus"})
    item9 = rc_menu:add_item({label = "Chorus Post Fill"})            
    item10 = rc_menu:add_item({label = "<Chorus Fill"})
            
  item115 = rc_menu:add_item({label = ">Intro"})
    item11 = rc_menu:add_item({label = "Intro"})
    item12 = rc_menu:add_item({label = "Intro Post Fill"})            
    item13 = rc_menu:add_item({label = "<Intro Fill"})           

  item120 = rc_menu:add_item({label = ">Bridge"})
    item14 = rc_menu:add_item({label = "Bridge"})
    item15 = rc_menu:add_item({label = "Bridge Post Fill"})            
    item16 = rc_menu:add_item({label = "<Bridge Fill"})

  item125 = rc_menu:add_item({label = ">Pre Chorus"})
    item17 = rc_menu:add_item({label = "Pre Chorus"})
    item18 = rc_menu:add_item({label = "Pre Chorus Post Fill"})            
    item19 = rc_menu:add_item({label = "<Pre Chorus Fill"})
    
  item130 = rc_menu:add_item({label = ">Rest-Shot-Hold"})
    item20 = rc_menu:add_item({label = "Rest"})
    item21 = rc_menu:add_item({label = "Shot"})            
    item22 = rc_menu:add_item({label = "<Hold"})
  item23 = rc_menu:add_item({label = "Drum Riff"})  
  item24 = rc_menu:add_item({label = "<Play Anywhere"})      
  item135 = rc_menu:add_item({label = ">Font Size"})
    item25 = rc_menu:add_item({label = "30"})
    item26 = rc_menu:add_item({label = "35"})
    item27 = rc_menu:add_item({label = "<40"})  
item28 = rc_menu:add_item({label = "Long Chords=Small Font|"})

  item29 = rc_menu:add_item({label = "Insert Measures"})
  item30 = rc_menu:add_item({label = "Remove Measures"})
  item31 = rc_menu:add_item({label = "Copy Measures"})           
  item32 = rc_menu:add_item({label = "Paste Measures (Insert)"})
  item33 = rc_menu:add_item({label = "Paste Measures (Over)"})  
  item34 = rc_menu:add_item({label = "Paste Measures (Chords only Insert)"})  
  item35 = rc_menu:add_item({label = "Paste Measures (Chords only Over)"})
  item36 = rc_menu:add_item({label = "Add Measures to End"})
  
   
 
 -- Let's add a command to all created items:
 for i=1, #rc_menu.items do
   rc_menu.items[i].command = function()
                                
                                if rc_menu.val == 1.0 then 
                                   commandID1 = reaper.NamedCommandLookup("_RS6c1d47c18a8623f9bec4db6a38f5f3244340130b")
                                   reaper.Main_OnCommand(commandID1, 0) end -- Script: ReaTrak merge region under cursor and the previous one.eel
                                if rc_menu.val == 2.0 then 
                                   commandID2 = reaper.NamedCommandLookup("_RSeae17cd68b428108b82f3d5bb6296c7f7661c4e3")
                                   reaper.Main_OnCommand(commandID2, 0) end -- Script: ReaTrak merge region under cursor and the next one.eel
                                if rc_menu.val == 3.0 then 
                                   commandID3 = reaper.NamedCommandLookup("_RS6c1d47c18a8623f9bec4db6a38f5f3244340130b")
                                   reaper.Main_OnCommand(commandID3, 0) end -- Script: ReaTrak merge region under cursor and the previous one.eel 
                                if rc_menu.val == 4.0 then 
                                   commandID4 = reaper.NamedCommandLookup("_RS466b2267ad0d3116809f7817da403d7eacaf9c42")
                                   reaper.Main_OnCommand(commandID4, 0) end -- Script: ReaTrak set to countin.eel
                                if rc_menu.val == 5.0 then 
                                   commandID5 = reaper.NamedCommandLookup("_RS5c97a93fa5eada118ad6ee1652872905b3aed33b")
                                   reaper.Main_OnCommand(commandID5, 0) end -- Script: ReaTrak set to verse.eel
                                if rc_menu.val == 6.0 then 
                                   commandID6 = reaper.NamedCommandLookup("_RS2b5a09cb0f7181f5a9eb036c0a61cb04e11e1ba6")
                                   reaper.Main_OnCommand(commandID6, 0) end -- Script: ReaTrak set to verse post fill.eel                                   
                                if rc_menu.val == 7.0 then 
                                   commandID7 = reaper.NamedCommandLookup("_RS3502d3cdd9d9812797d913025aca95ed72f81d48")
                                   reaper.Main_OnCommand(commandID7, 0) end -- Script: ReaTrak set to verse fill.eel                                   
                                if rc_menu.val == 8.0 then 
                                   commandID8 = reaper.NamedCommandLookup("_RS742ade11d4ff6840f6879ccfefbea1b5622a225c")
                                   reaper.Main_OnCommand(commandID8, 0) end -- Script: ReaTrak set to chorus.eel                                   
                                if rc_menu.val == 9.0 then 
                                   commandID9 = reaper.NamedCommandLookup("_RS69d6686e5c296736944a38e8c9e2763bc572be39")
                                   reaper.Main_OnCommand(commandID9, 0) end -- Script: ReaTrak set to chorus post fill.eel                                  
                                if rc_menu.val == 10.0 then 
                                   commandID10 = reaper.NamedCommandLookup("_RS3177dbcb716dfd33df36bb975389d7af6b20c833")
                                   reaper.Main_OnCommand(commandID10, 0) end -- Script: ReaTrak set to chorus fill.eel                                   
                                if rc_menu.val == 11.0 then 
                                   commandID11 = reaper.NamedCommandLookup("_RS11e438864bf5da83f4f9b5564f833f3c71397c33")
                                   reaper.Main_OnCommand(commandID11, 0) end -- Script: ReaTrak set to intro.eel                                   
                                if rc_menu.val == 12.0 then 
                                   commandID12 = reaper.NamedCommandLookup("_RSaac3c353685cef325faeaca5e05bfa0e725e14f7")
                                   reaper.Main_OnCommand(commandID12, 0) end -- Script: ReaTrak set to intro post fill.eel                                   
                                if rc_menu.val == 13.0 then 
                                   commandID13 = reaper.NamedCommandLookup("_RS0ef53ac94f8e68c5870c6b3f2ffa4775492ff737")
                                   reaper.Main_OnCommand(commandID13, 0) end -- Script: ReaTrak set to intro fill.eel                                   
                                if rc_menu.val == 14.0 then 
                                   commandID14 = reaper.NamedCommandLookup("_RS40ff5eb0a34e28bad5c662a3b9f3130ebff321a3")
                                   reaper.Main_OnCommand(commandID14, 0) end -- Script: ReaTrak set to bridge.eel                                   
                                if rc_menu.val == 15.0 then 
                                   commandID15 = reaper.NamedCommandLookup("_RSa679a599cabfc05f57e983b005dd66259811a811")
                                   reaper.Main_OnCommand(commandID15, 0) end -- Script: ReaTrak set to bridge post fill.eel                                   
                                if rc_menu.val == 16.0 then 
                                   commandID16 = reaper.NamedCommandLookup("_RS5d12e40d559d291599d7144de9622bee2b1d91d6")
                                   reaper.Main_OnCommand(commandID16, 0) end -- Script: ReaTrak set to bridge fill.eel                                   
                                if rc_menu.val == 17.0 then 
                                   commandID17 = reaper.NamedCommandLookup("_RS889edadcc4c7ff0264ede8feedf3ea69dc714595")
                                   reaper.Main_OnCommand(commandID17, 0) end -- Script: ReaTrak set to pre chorus.eel                                  
                                if rc_menu.val == 18.0 then 
                                   commandID18 = reaper.NamedCommandLookup("_RSa696c463f4a0acdae5833b6f42c72465350fdc40")
                                   reaper.Main_OnCommand(commandID18, 0) end -- Script: ReaTrak set to pre chorus post fill.eel                                   
                                if rc_menu.val == 19.0 then 
                                   commandID19 = reaper.NamedCommandLookup("_RS8ae2b25083efeab5740bdcc7250ea42bb7d56125")
                                   reaper.Main_OnCommand(commandID19, 0) end -- Script: ReaTrak set to pre chorus fill.eel                                   
                                if rc_menu.val == 20.0 then 
                                   commandID20 = reaper.NamedCommandLookup("_RSa8aad6679b6fe5cea45f09c33dbbc324402bead4")
                                   reaper.Main_OnCommand(commandID20, 0) end -- Script: ReaTrak set to rest.eel                                  
                                if rc_menu.val == 21.0 then 
                                   commandID21 = reaper.NamedCommandLookup("_RSf796e5c420274adc90caa3357f804106d545a0a2")
                                   reaper.Main_OnCommand(commandID21, 0) end -- Script: ReaTrak set to shot.eel                                   
                                if rc_menu.val == 22.0 then 
                                   commandID22 = reaper.NamedCommandLookup("_RSd8a4c0b6ae393af67086afe4529b38e2ecaa81fc")
                                   reaper.Main_OnCommand(commandID22, 0) end -- Script: ReaTrak set to hold.eel                                   
                                if rc_menu.val == 23.0 then 
                                   commandID23 = reaper.NamedCommandLookup("_RSbb834461f56b0c714866be9b83b09de77a2ca74a")
                                   reaper.Main_OnCommand(commandID23, 0) end -- Script: ReaTrak set to drum riff.eel                                   
                                if rc_menu.val == 24.0 then 
                                   commandID24 = reaper.NamedCommandLookup("_RSe4280fe62bcd5259713361d2f8a072f93c01e974")
                                   reaper.Main_OnCommand(commandID24, 0) end -- Script: ReaTrak set to play anywhere.eel                                  
                                if rc_menu.val == 25.0 then chord_font_size = 40 end
                                if rc_menu.val == 26.0 then chord_font_size = 35 end
                                if rc_menu.val == 27.0 then chord_font_size = 29 end
                                if rc_menu.val == 28.0 then chord_length = 1 end
                                
                                if rc_menu.val == 29.0 then 
                                   commandID29 = reaper.NamedCommandLookup("_RS23acb776ffe94d80871fc7abd6d153797ef54f54")
                                   reaper.Main_OnCommand(commandID29, 0) end -- Script: ReaTrak insert measures at cursor.lua                                  
                                if rc_menu.val == 30.0 then 
                                   commandID30 = reaper.NamedCommandLookup("_RS9eeb7f429ea27a1c74caa0ad263145ce8db4308f")
                                   reaper.Main_OnCommand(commandID30, 0) end -- Script: ReaTrak remove measures at cursor.lua                                  
                                if rc_menu.val == 31.0 then 
                                   commandID31 = reaper.NamedCommandLookup("_RSfc9e39d9412a25955da22e75e17ce7b862cebdd8")
                                   reaper.Main_OnCommand(commandID31, 0) end -- Script: ReaTrak copy measures at cursor.lua                                  
                                if rc_menu.val == 32.0 then 
                                   commandID32 = reaper.NamedCommandLookup("_RS75b17c8d2da7ff0d06f8842d54ee009254e24eca")
                                   reaper.Main_OnCommand(commandID32, 0) end -- Script: ReaTrak paste measures at cursor (insert).lua                                   
                                if rc_menu.val == 33.0 then 
                                   commandID33 = reaper.NamedCommandLookup("_RS1e1977a05f1feb05995e629c9f492c49bdd4d3a3")
                                   reaper.Main_OnCommand(commandID33, 0) end -- Script: ReaTrak paste measures at cursor (over).lua
                                if rc_menu.val == 34.0 then 
                                   commandID34 = reaper.NamedCommandLookup("_RSdb42014926973c7f583c679cff3fafea81164d25")
                                   reaper.Main_OnCommand(commandID34, 0) end -- Script: ReaTrak paste measures at cursor (chords only insert).lua                                  
                                if rc_menu.val == 35.0 then 
                                   commandID35 = reaper.NamedCommandLookup("_RS6247c96c011248d0d37be65dbecc8297d28315fd")
                                   reaper.Main_OnCommand(commandID35, 0) end -- Script: ReaTrak paste measures at cursor (chords only over).lua 
                                if rc_menu.val == 36.0 then 
                                   commandID36 = reaper.NamedCommandLookup("_RS83340c1565b9cab4f7862e28c730be093561e59c")
                                   reaper.Main_OnCommand(commandID36, 0) end -- Script: ReaTrak add measures to end.lua                                                                                                        
                               --msg("Last clicked item: " .. rc_menu.items[i].id)
                                --msg("gfx.menushow returns: " .. rc_menu.val)
                                --msg("ID "..rc_menu.get_item)
                                --msg("If values match -> everything worked better than expected :)\n")
                                
                              end
 end
 
  
   
  ---------------------------------------------------
  function ExtState_Def()  
    local t= {
            -- globals
            mb_title = 'Region chord editor',
            ES_key = 'MPL_Region chord editor',
            wind_x =  50,
            wind_y =  50,
            wind_w =  450,
            wind_h =  450,
            dock =    0,
            
            -- mouse
            mouse_wheel_res = 960,
            activetab = 1, 
            
            -- data
            app_on_strategy_change = 0,
            app_on_slider_click = 1,
            app_on_slider_release = 1, 
            app_on_groove_change = 0,
            iterationlim = 30000, -- deductive brutforce
            
            }
    return t
  end  
  ---------------------------------------------------
  function round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    return math.floor(num * mult + 0.5) / mult
  end 
  ---------------------------------------------------    
  function run()
    obj.clock = os.clock()
    
    MOUSE(conf, obj, data, refresh, mouse)
    CheckUpdates(obj, conf, refresh)
    Data_Update2 (conf, obj, data, refresh, mouse) 
    if refresh.data == true then 
      Data_Update (conf, obj, data, refresh, mouse) 
      refresh.data = nil 
    end    
  
    if refresh.conf == true then 
      ExtState_Save(conf)
      refresh.conf = nil 
    end
    
    if refresh.GUI == true or refresh.GUI_onStart == true then
      OBJ_Update              (conf, obj, data, refresh, mouse,strategy) end  
    if refresh.GUI_minor == true then refresh.GUI = true end
    GUI_draw               (conf, obj, data, refresh, mouse, strategy)    
                                               
 
    ShortCuts(conf, obj, data, refresh, mouse)
    if mouse.char >= 0 and mouse.char ~= 27 
      then defer(run) else atexit(gfx.quit) end
  end
    
  
  
---------------------------------------------------------------------
  function CheckFunctions(str_func) local SEfunc_path = reaper.GetResourcePath()..'/Scripts/ReaTrak/ReaTrak mpl_Various_functions.lua' local f = io.open(SEfunc_path, 'r')  if f then f:close() dofile(SEfunc_path) if not _G[str_func] then  reaper.MB('Update '..SEfunc_path:gsub('%\\', '/')..' to newer version', '', 0) else return true end  else reaper.MB(SEfunc_path:gsub('%\\', '/')..' missing', '', 0) end   end

  --function CheckFunctions(str_func) local SEfunc_path = reaper.GetResourcePath()..'/Scripts/ReaTrak/ReaTrak mpl_Various_functions.lua' local f = io.open(SEfunc_path, 'r')  if f then f:close() dofile(SEfunc_path) if not _G[str_func] then  reaper.MB('Update '..SEfunc_path:gsub('%\\', '/')..' to newer version', '', 0) else return true end  else reaper.MB(SEfunc_path:gsub('%\\', '/')..' missing', '', 0) end   end

---------------------------------------------------------------------
  function Data_Update (conf, obj, data, refresh, mouse) 
    data.pr_len = GetProjectLength( 0 )
    local retval, measures, cml, fullbeats, cdenom = TimeMap2_timeToBeats( 0, data.pr_len )
    data.pr_len_measures = measures
    data.measures = {}
    data.chordcolorsmap = {}
    for i = 0, data.pr_len_measures do
      local meas_time = TimeMap2_beatsToTime( 0, 0, i )
      local retval, measures, cml, fullbeats, cdenom = TimeMap2_timeToBeats( 0, meas_time )
      local chord_t = {}
      for b = 0, cml do
        local meas_time0 = TimeMap2_beatsToTime( 0, b, i )
        local markeridx, regionidx = GetLastMarkerAndCurRegion( 0, meas_time0+0.001 )
        local retval, isrgn, pos, rgnend, name, markrgnindexnumber, color
        if regionidx >= 0 then
          retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = EnumProjectMarkers3( 0, regionidx )
          if name:match('@') then name = '' color = lastcolor end
         else 
          name = '' color = lastcolor 
        end
        chord_t[b] = {name=name,color=color}
        if not data.chordcolorsmap[name:lower()] then data.chordcolorsmap[name:lower()] = color end
        lastcolor = color
      end
      data.measures[i] = {cml = cml,
                          cdenom =cdenom,
                          chord_t = chord_t}
    end
    
  end
  ---------------------------------------------------
  function Data_Update2 (conf, obj, data, refresh, mouse) 
    if not data.pr_len_measures then return end
    if  GetPlayStateEx( 0 ) &1~=1 then data.curpos = GetCursorPositionEx( 0 ) else data.curpos = GetPlayPosition2Ex( 0 ) end
    local retval, measures, cml, fullbeats, cdenom = TimeMap2_timeToBeats( 0, data.curpos )
    data.cur_measure = measures
    data.cur_measure_progress = retval / cml
    data.proj_progress = data.cur_measure / data.pr_len_measures
    if not data.last_cur_measure or data.cur_measure ~= data.last_cur_measure then 
      obj.scroll_val = data.proj_progress
      refresh.GUI = true 
    end
    data.last_cur_measure = data.cur_measure
        
    for i = 0, data.pr_len_measures do
      if obj['meas'..i] then 
        if i  < data.cur_measure then
          obj['meas'..i].val = 1
         elseif i  == data.cur_measure then
          obj['meas'..i].val = data.cur_measure_progress 
         elseif i  > data.cur_measure then
          obj['meas'..i].val = 0     
        end
      end
    end
    
    --
    
    refresh.GUI_minor = true
  end
  ---------------------------------------------------
  function col(obj, col_str, a) 
    local r,g,b= table.unpack(obj.GUIcol[col_str])
    gfx.set(r,g,b ) 
    --if not GetOS():match('Win') then gfx.set(b,g,r ) end
    if a then gfx.a = a end  
  end

  
  ---------------------------------------------------
  function GUI_knob(obj, b)
    local x,y,w,h,val =b.x,b.y,b.w,b.h, b.val
    if not val then return end
    local arc_r = math.floor(w/2 * 0.7)
    if b.reduce_knob then arc_r = arc_r*b.reduce_knob end
    y = y - arc_r/2 + 1
    local ang_gr = 120
    local ang_val = math.rad(-ang_gr+ang_gr*2*val)
    local ang = math.rad(ang_gr)
    local thickness = 1.5
    local knob_y_shift = b.knob_y_shift
    if not knob_y_shift then knob_y_shift = 0 end
    
    col(obj, b.col, 0.08)
    if b.knob_as_point then 
      local y = y - 5
      local arc_r = arc_r*0.75
      for i = 0, thickness, 0.5 do
        gfx_arc(x+w/2,y+h/2+ knob_y_shift,arc_r-i, -ang_gr, ang_gr, ang_gr)
      end
      gfx.a = 0.02
      gfx.circle(x+w/2,y+h/2,arc_r, 1)
      return 
    end
    
    
    -- arc back      
    col(obj, b.col, 0.15)
    local halfh = math.floor(h/2)
    local halfw = math.floor(w/2)
    for i = 0, thickness, 0.5 do
      gfx_arc(x+w/2,y+h/2+ knob_y_shift,arc_r-i, -ang_gr, ang_gr, ang_gr)
    end
    
    
    
    local knob_a = 0.6
    if b.knob_a then knob_a = b.knob_a end
    col(obj, b.col, knob_a)      
    if not b.is_centered_knob then 
      -- val       
      local ang_val = -ang_gr+ang_gr*2*val
      for i = 0, thickness, 0.5 do
        gfx_arc(x+w/2,y+h/2+ knob_y_shift,arc_r-i, -ang_gr, ang_val, ang_gr)
      end
      
     else -- if centered
      for i = 0, thickness, 0.5 do
        if val< 0.5 then
          gfx_arc(x+w/2,y+h/2 + knob_y_shift,arc_r-i, -ang_gr+ang_gr*2*val, 0, ang_gr)
         elseif val> 0.5 then
          gfx_arc(x+w/2,y+h/2+ knob_y_shift,arc_r-i, 0, -ang_gr+ang_gr*2*val, ang_gr)
        end
      end    
          
    end 
  end
  ---------------------------------------------------
  function gfx_arc(x,y,r, start_ang0, end_ang0, lim_ang, y_shift0)
    local start_ang = start_ang0
    local end_ang = end_ang0
    local y_shift = y_shift0
    if not y_shift0 then y_shift = 0 end
    local x = math.floor(x)
    local y = math.floor(y)
    local has_1st_segm = (start_ang <= -90) or (end_ang <= -90)
    local has_2nd_segm = (start_ang > -90 and start_ang <= 0) or (end_ang > -90 and end_ang <= 0) or (start_ang<=-90 and end_ang >= 0 )
    local has_3rd_segm = (start_ang >= 0 and start_ang <= 90) or (end_ang > 0 and end_ang <= 90) or (start_ang<=0 and end_ang >= 90 )
    local has_4th_segm = (start_ang > 90) or (end_ang > 90)
    
    if has_1st_segm then  gfx.arc(x,y+1 +y_shift,r, math.rad(math.max(start_ang,-lim_ang)), math.rad(math.min(end_ang, -90)),    1) end
    if has_2nd_segm then  gfx.arc(x,y+y_shift,r, math.rad(math.max(start_ang,-90)), math.rad(math.min(end_ang, 0)),    1) end
    if has_3rd_segm then gfx.arc(x+1,y+y_shift,r, math.rad(math.max(start_ang,0)), math.rad(math.min(end_ang, 90)),    1) end
    if has_4th_segm then  gfx.arc(x+1,y+1+y_shift,r, math.rad(math.max(start_ang,90)), math.rad(math.min(end_ang, lim_ang)),    1)  end
  end
  ---------------------------------------------------
  function GUI_DrawObj(obj, o, mouse, conf)
    if not o then return end
    gfx.dest = 1
    local x,y,w,h, txt = o.x, o.y, o.w, o.h, o.txt
    --gfx.set(1,1,1,1)gfx.rect(x,y,w,h,0)   
    
    if not x or not y or not w or not h then return end
    gfx.a = o.alpha_back or 0.15
    
    if not o.disable_blitback then
      local blit_h, blit_w = obj.grad_sz,obj.grad_sz
      gfx.blit( 5, 1, 0, -- grad back
              0,0,  blit_w,blit_h,
              x,y,w,h, 0,0)  
    end   
    
    ------------------ fill back
      local x_sl = x      
      local w_sl = w 
      local y_sl = y      
      local h_sl = h 
      if o.colint and o.col then
        local r, g, b = ColorFromNative( o.colint )
        gfx.set(r/255,g/255,b/255, o.alpha_back or 0.2)
       else
        if o.col then col(obj, o.col, o.alpha_back or 0.2) end 
      end
      if o.col_int2 then
        local r, g, b = ColorFromNative( o.col_int2 )
        gfx.set(r/255,g/255,b/255, o.col_int2_a)
        gfx.rect(x,y, w,h,1)
      end
  
    if o.val then 
      gfx.set(1,1,1,0.7) -- 0.7) progress bar alpha
      gfx.rect(x,y, w * o.val,h,1)
    end
  
  
    -- color fill
      if not o.colfill_frame and o.colfill_col then
        
        col(obj, o.colfill_col, o.colfill_a or 1) 
        gfx.rect(x,y,w,h,1)   
       elseif    o.colfill_frame and o.colfill_col  then
        gfx.a = 0.8
        local blit_h, blit_w = obj.grad_sz,obj.grad_sz
        gfx.blit( 5, 1, 0, -- grad back
              0,math.rad(180),  blit_w,blit_h,
              x,y,w,h, 0,0)   
        col(obj, o.colfill_col, o.colfill_a*0.7 or 1) 
        gfx.rect(x,y,w,h,1)                    
      end
             
    ------------------ check
    local check_ex = ((type(o.check)=='boolean' and o.check==true) or (o.check and o.check&1==1))
                        or ((type(o.check)=='boolean' and o.check==false) or (o.check and o.check&1==0))
    --if o.check then
      gfx.a = 0.8
      if (type(o.check)=='boolean' and o.check==true) or (o.check and o.check&1==1) then
        local xr = x+2
        local yr = y+2
        local wr = h-6
        local hr = h-5
        gfx.rect(xr,yr,wr,hr,1)
        rect(x,y,h-3,h-2,0)
       elseif (type(o.check)=='boolean' and o.check==false) or (o.check and o.check&1==0) then
        rect(x,y,h-3,h-2,0)
      end
    --end
      
    


  
    ------------------ txt
    -- text 
      local txt
      if not o.txt then txt = '' else txt = tostring(o.txt) end
      --if not o.txt then txt = '>' else txt = o.txt..'|' end
      ------------------ txt
        if txt and w > 0 then 
          if o.txt_col then col(obj, o.txt_col)else col(obj, 'white') end
          if o.txt_a then 
            gfx.a = o.txt_a 
            if o.outside_buf then gfx.a = o.txt_a*0.8 end
           else 
            gfx.a = 0.8 
          end
          gfx.setfont(1, obj.GUI_font, o.fontsz or obj.GUI_fontsz )
          local shift = 2
          local cnt = 0
          for line in txt:gmatch('[^\r\n]+') do cnt = cnt + 1 end
          local com_texth = gfx.texth*cnt
          local i = 0
          local reduce1, reduce2 = 2, nil
          if o.aligh_txt and o.aligh_txt&8==8 then reduce1, reduce2 = 0,-2 end
            local txt_t = {}
            
            if not o.txt_wrap then 
              for line in txt:gmatch('[^\r\n]+') do txt_t[#txt_t+1] = line end
             else
              local lim_wr = 10
              for line in txt:gmatch('[^\r\n]+') do 
                if gfx.measurestr(line) > w -lim_wr then 
                  local str = ''
                  for symb = 1, string.len(line) do
                    str = str..line:sub(symb,symb)
                    if gfx.measurestr(str) > w -lim_wr then 
                      txt_t[#txt_t+1] = str
                      str = ''
                    end
                  end
                  txt_t[#txt_t+1] = str
                 else
                  txt_t[#txt_t+1] = line
                end   
              end
            end
            
            local comy_shift = ((#txt_t-1) * gfx.texth)/2
            for lineid = 1, #txt_t do
              local line = txt_t[lineid]
              --[[if gfx.measurestr(line:sub(2)) > w -5 and w > 20 then                 
                repeat line = line:sub(reduce1, reduce2) until gfx.measurestr(line..'...') < w -5
                if o.aligh_txt and o.aligh_txt&8==8 then line = line..'...' else line = '...'..line end                
              end]]
              gfx.x = x+ math.ceil((w-gfx.measurestr(line))/2)
              gfx.y = y+ h/2 - com_texth/2 + i*gfx.texth - comy_shift
              if o.aligh_txt then
                if o.aligh_txt&1==1 then 
                  gfx.x = x + shift 
                  if check_ex then gfx.x = gfx.x + o.h end
                end -- align left
                if o.aligh_txt&2==2 then gfx.y = y + i*gfx.texth end -- align top
                if o.aligh_txt&4==4 then gfx.y = y + h - com_texth+ gfx.texth*i end -- align bot
                if o.aligh_txt&8==8 then gfx.x = x + w - gfx.measurestr(line) - shift end -- align right
                if o.aligh_txt&16==16 then gfx.y = y + (h - com_texth)/2+ i*gfx.texth - 2 end -- align center
                if o.txt_x_shift then gfx.x =  gfx.x  + o.txt_x_shift end
              end
              gfx.drawstr(line)
              --shift = shift + gfx.texth
              i = i + 1
            end
            
        end                


      
    ------------------ frame
      if o.a_frame and o.col then  -- low frame
        col(obj, o.col, o.a_frame or 0.2)
        gfx.rect(x,y,w,h,0)
        gfx.x,gfx.y = x,y
        gfx.lineto(x,y+h)
        gfx.x,gfx.y = x+1,y+h
        --gfx.lineto(x+w,y+h)
        gfx.x,gfx.y = x+w,y+h-1
        --gfx.lineto(x+w,y)
        gfx.x,gfx.y = x+w-1,y
        gfx.lineto(x+1,y)
      end    

    -- highlight
    if o.is_selected then
      col(obj, 'white', 0.2)
      --gfx.rect(x,y,w,h,1)
      gfx.a = 0.4
      local h0 = math.floor(h/2)
      gfx.blit( 3, 1, math.rad(180), -- grad back
                0,0,  obj.grad_sz,obj.grad_sz,
                x,y,w,h0, 0,0)  
      gfx.blit( 3, 1, 0, -- grad back
                0,0,  obj.grad_sz,obj.grad_sz,
                x,y+h0,w,h0, 0,0)                  
    end
    
      
    
    return true
  end
---------------------------------------------------  
  function GUI_gradBack(conf, obj, data, refresh, mouse)
    -- com grad
    gfx.dest = 2
    gfx.setimgdim(2, -1, -1)  
    gfx.setimgdim(2, obj.grad_sz,obj.grad_sz)  
    local r,g,b,a = 1,1,1,0.72
    gfx.x, gfx.y = 0,0
    local c = 0.8
    local drdx = c*0.00001
    local drdy = c*0.00001
    local dgdx = c*0.00008
    local dgdy = c*0.0001    
    local dbdx = c*0.00008
    local dbdy = c*0.00001
    local dadx = c*0.0001
    local dady = c*0.0001       
    gfx.gradrect(0,0, obj.grad_sz,obj.grad_sz, 
                    r,g,b,a, 
                    drdx, dgdx, dbdx, dadx, 
                    drdy, dgdy, dbdy, dady) 
  end
  
    ---------------------------------------------------  
  function GUI_gradDrawObj(conf, obj, data, refresh, mouse)
    gfx.dest = 5
    gfx.setimgdim(5, -1, -1)  
    gfx.setimgdim(5, obj.grad_sz,obj.grad_sz)  
    local r,g,b,a = 1,1,1,0.6
    gfx.x, gfx.y = 0,0
    local c = 1
    local drdx = c*0.001
    local drdy = c*0.01
    local dgdx = c*0.001
    local dgdy = c*0.001    
    local dbdx = c*0.00003
    local dbdy = c*0.001
    local dadx = c*0.00004
    local dady = c*0.00001       
    gfx.gradrect(0,0, obj.grad_sz,obj.grad_sz, 
                    r,g,b,a, 
                    drdx, dgdx, dbdx, dadx, 
                    drdy, dgdy, dbdy, dady) 
                    gfx.dest = -1  
  end    
  ---------------------------------------------------  
  function GUI_gradSelection(conf, obj, data, refresh, mouse)
        gfx.dest = 3
        gfx.setimgdim(3, -1, -1)  
        gfx.setimgdim(3, obj.grad_sz,obj.grad_sz)  
        local r,g,b,a = 1,1,1,0.2
        gfx.x, gfx.y = 0,0
        local c = 0.8
        local drdx = c*0.00001
        local drdy = c*0.00001
        local dgdx = c*0.00008
        local dgdy = c*0.00001    
        local dbdx = c*0.00008
        local dbdy = c*0.00001
        local dadx = c*0.0005
        local dady = c*0.003       
        gfx.gradrect(0,0, obj.grad_sz,obj.grad_sz, 
                        r,g,b,a, 
                        drdx, dgdx, dbdx, dadx, 
                        drdy, dgdy, dbdy, dady)  
  end 
    ---------------------------------------------------
  function GUI_draw(conf, obj, data, refresh, mouse, strategy)
    gfx.mode = 0
    
    -- 1 main
    -- 2 gradient back
    --  3 grad selection
    -- 5 gradient Draw Obj\
    
    --  init
      if refresh.GUI_onStart then
        GUI_gradBack(conf, obj, data, refresh, mouse)
        GUI_gradDrawObj(conf, obj, data, refresh, mouse)
        GUI_gradSelection(conf, obj, data, refresh, mouse)
        refresh.GUI_onStart = nil             
        refresh.GUI = true       
      end
      
    -- refresh
      if refresh.GUI then 
          gfx.dest = 1
          gfx.setimgdim(1, -1, -1)  
          gfx.setimgdim(1, gfx.w, gfx.h) 
          gfx.blit( 2, 1, 0, -- grad back
                    0,0,  obj.grad_sz,obj.grad_sz/2,
                    0,0,  gfx.w,gfx.h, 0,0)                
        -- refresh all buttons
          for key in spairs(obj) do 
            if type(obj[key]) == 'table' and obj[key].show and not obj[key].blit and not obj[key].strategy_reserved then 
              GUI_DrawObj(obj, obj[key], mouse, conf) 
            end  
          end  
      end
    
 
      
    --  render    
      gfx.dest = -1   
      gfx.a = 1
      gfx.x,gfx.y = 0,0
      --gfx.set(1,1,1,0.2)
      --gfx.rect(0,0,gfx.w, gfx.h/4,1)
    --  back
      gfx.blit(4, 1, 0, -- backgr
          0,0,gfx.w, gfx.h,
          0,0,gfx.w, gfx.h, 0,0)      
      gfx.blit(1, 1, 0, -- backgr
          0,0,gfx.w, gfx.h,
          0,0,gfx.w, gfx.h, 0,0)  
    

    refresh.GUI = nil
    refresh.GUI_minor = nil
    gfx.update()
  end

  ---------------------------------------------------
  function ShortCuts(conf, obj, data, refresh, mouse)
      if mouse.char == 32 then Main_OnCommandEx(40044, 0,0) end -- space: play/pause
  end
  ---------------------------------------------------
  function MOUSE_Match(mouse, b)
    if not b then return end
    if b.x and b.y and b.w and b.h then 
      local state= mouse.x > b.x
               and mouse.x < b.x+b.w
               and mouse.y > b.y
               and mouse.y < b.y+b.h
      if state and not b.ignore_mouse then 
        mouse.context = b.context 
        return true, (mouse.x - b.x) / b.w
      end
    end  
  end
   ------------------------------------------------------------------------------------------------------
  function MOUSE(conf, obj, data, refresh, mouse)
    local d_click = 0.4
    mouse.char =gfx.getchar() 
    
    mouse.cap = gfx.mouse_cap
    mouse.x = gfx.mouse_x
    mouse.y = gfx.mouse_y
    mouse.LMB_state = gfx.mouse_cap&1 == 1 
    mouse.RMB_state = gfx.mouse_cap&2 == 2 
    mouse.MMB_state = gfx.mouse_cap&64 == 64
    mouse.Ctrl_LMB_state = gfx.mouse_cap&5 == 5 
    mouse.Ctrl_state = gfx.mouse_cap&4 == 4 
    mouse.Shift_state = gfx.mouse_cap&8 == 8 
    mouse.Alt_state = gfx.mouse_cap&16 == 16 -- alt
    mouse.wheel = gfx.mouse_wheel
    --mouse.context = '_window'
    mouse.is_moving = mouse.last_x and mouse.last_y and (mouse.last_x ~= mouse.x or mouse.last_y ~= mouse.y)
    mouse.wheel_trig = mouse.last_wheel and (mouse.wheel - mouse.last_wheel) 
    mouse.wheel_on_move = mouse.wheel_trig and mouse.wheel_trig ~= 0
    if (mouse.LMB_state and not mouse.last_LMB_state) or (mouse.MMB_state and not mouse.last_MMB_state) then  
       mouse.last_x_onclick = mouse.x     
       mouse.last_y_onclick = mouse.y 
       mouse.LMB_state_TS = os.clock()
    end  
    
    
     mouse.DLMB_state = mouse.LMB_state 
                        and not mouse.last_LMB_state
                        and mouse.last_LMB_state_TS
                        and mouse.LMB_state_TS- mouse.last_LMB_state_TS > 0
                        and mouse.LMB_state_TS -mouse.last_LMB_state_TS < d_click 

  
     if mouse.last_x_onclick and mouse.last_y_onclick then 
      mouse.dx = mouse.x - mouse.last_x_onclick  mouse.dy = mouse.y - mouse.last_y_onclick 
     else 
      mouse.dx, mouse.dy = 0,0 
    end
   
   
        -- loop with break
        
        for key in spairs(obj,function(t,a,b) return b < a end) do
         if type(obj[key]) == 'table' and not obj[key].ignore_mouse then
           ------------------------
           local is_mouse_over = MOUSE_Match(mouse, obj[key])
           if ((is_mouse_over and not mouse.last_LMB_state and not mouse.LMB_state )
                or (mouse.context_latch and mouse.context_latch == key))
            and obj[key].func_mouseover then obj[key].func_mouseover() end
            ------------------------
           if is_mouse_over and mouse.LMB_state and not mouse.last_LMB_state then mouse.context_latch = key end
           ------------------------
           mouse.onclick_L = not mouse.last_LMB_state 
                               and mouse.cap == 1
                               and is_mouse_over
          if mouse.onclick_L and obj[key].func then skip_edit=0 obj[key].func() goto skip_mouse_obj end
           ------------------------
           mouse.onrelease_L = not mouse.LMB_state  -- release under object
                               and mouse.last_LMB_state 
                               and is_mouse_over 
          if mouse.onrelease_L and obj[key].onrelease_L then obj[key].onrelease_L() goto skip_mouse_obj end   
           mouse.onrelease_L2 = not mouse.LMB_state -- release of previous latch object
                               and mouse.last_LMB_state 
                               and mouse.context_latch == key 
          if mouse.onrelease_L2 and obj[key].onrelease_L2 then obj[key].onrelease_L2() goto skip_mouse_obj end                  
           ------------------------
           mouse.ondrag_L = -- left drag (persistent even if not moving)
                               mouse.cap == 1
                               and not mouse.Ctrl_state 
                               and (mouse.context == key or mouse.context_latch == key) 
                               
           if mouse.ondrag_L and obj[key].func_LD then obj[key].func_LD() end 
                 ------------------------
           mouse.ondrag_L_onmove = -- left drag (only when moving after latch)
                               mouse.cap == 1
                               and mouse.is_moving
                               and mouse.context_latch == key
           if mouse.ondrag_L_onmove and obj[key].func_LD2 then obj[key].func_LD2() end 
                 ------------------------              
           mouse.onclick_LCtrl = mouse.LMB_state 
                               and not mouse.last_LMB_state 
                               and mouse.cap == 5
                               and is_mouse_over
           if mouse.onclick_LCtrl and obj[key].func_trigCtrl then obj[key].func_trigCtrl() end
           mouse.onclick_LShift = mouse.LMB_state 
                               and not mouse.last_LMB_state 
                               and mouse.cap == 9
                               and is_mouse_over
           if mouse.onclick_LShift and obj[key].func_trigShift then obj[key].func_trigShift() end           
                 ------------------------              
           mouse.onclick_LAlt = not mouse.last_LMB_state 
                               and mouse.cap == 17   -- alt + lclick
                               and is_mouse_over
          if mouse.onclick_LAlt  then 
              if obj[key].func_L_Alt then obj[key].func_L_Alt() end
              goto skip_mouse_obj  
          end           
                 ------------------------            
           mouse.ondrag_LCtrl = -- left drag (persistent even if not moving)
                               mouse.LMB_state 
                               and mouse.Ctrl_state 
                               and mouse.context_latch == key
                               
           if mouse.ondrag_LCtrl and obj[key].func_ctrlLD then obj[key].func_ctrlLD() end 
                 ------------------------
           
           mouse.onclick_R = mouse.cap == 2
                               and not mouse.last_RMB_state 
                               and is_mouse_over 
           if mouse.onclick_R and obj[key].func_R then obj[key].func_R() end
           --if mouse.onclick_R then reaper.Main_OnCommand(40044,0) end -- Transport: Play/stop
           --if mouse.onclick_R then rc_menu:show(mouse.x, mouse.y) end
           --if mouse.onclick_R and obj[key].func_R then obj[key].func_R() skip_edit=0 goto skip_mouse_obj end
           if mouse.onclick_R and obj[key].func then skip_edit=1 obj[key].func() goto skip_mouse_obj end
           --if mouse.onclick_R then skip_edit=0 goto skip_mouse_obj end
           --if mouse.onclick_R and obj[key].func_R then reaper.SetEditCurPos(pos_start, 1, 0) end
           --if mouse.onclick_R then Data_AddChord() end
           
           --[[
           if not mouse.last_RMB_state and gfx.mouse_cap&2 == 2 then
             -- right click pressed down -> show "right click menu" at mouse cursor
             --reaper.SetEditCurPos(pos_start, 1, 0)
             skip_edit=1
             rc_menu:show(mouse.x, mouse.y)
             obj[key].func() goto skip_mouse_obj
           end
           --]]
                 ------------------------                
           mouse.ondrag_R = --
                               mouse.RMB_state 
                               and not mouse.Ctrl_state 
                               and (mouse.context == key or mouse.context_latch == key) 
                               and mouse.is_moving
           if mouse.ondrag_R and obj[key].func_RD then obj[key].func_RD() end 
                 ------------------------  
           mouse.onwheel = mouse.wheel_trig 
                           and mouse.wheel_trig ~= 0 
                           and not mouse.Ctrl_state 
                           and mouse.context == key
           if mouse.onwheel and obj[key].func_wheel then obj[key].func_wheel(mouse.wheel_trig) end
         end
       end
       

       
       ::skip_mouse_obj::
    
    
    
    if not MOUSE_Match(mouse, {x=0,y=0,w=gfx.w, h=gfx.h}) then obj.tooltip = '' end
    
     -- mouse release    
      if mouse.last_LMB_state and not mouse.LMB_state   then  
        -- clear context
        mouse.context_latch = ''
        mouse.context_latch_val = -1
        mouse.context_latch_t = nil
        --Main_OnCommand(NamedCommandLookup('_BR_FOCUS_ARRANGE_WND'),0)
        refresh.GUI_minor = true
      end
    
    
    
    -- Middle drag
      if mouse.MMB_state and not mouse.last_MMB_state then       
        mouse.context_latch_t = {x= conf.struct_xshift,
                                y= conf.struct_yshift}
      end
      
      if mouse.MMB_state and mouse.last_MMB_state and  mouse.is_moving then 
        conf.struct_xshift = mouse.context_latch_t.x  + mouse.dx
        conf.struct_yshift = mouse.context_latch_t.y + mouse.dy
        refresh.GUI = true
        refresh.conf = true
      end

      if not mouse.MMB_state and mouse.last_MMB_state then
        mouse.context_latch_t = nil
        refresh.GUI = true
        refresh.conf = true
      end
      
    -- any key to refresh
      if not mouse.last_char or mouse.last_char ~= mouse.char then 
          refresh.GUI_minor = true 
      end
      
      mouse.last_char =mouse.char
      mouse.last_context = mouse.context
       mouse.last_x = mouse.x
       mouse.last_y = mouse.y
       mouse.last_LMB_state = mouse.LMB_state  
       mouse.last_RMB_state = mouse.RMB_state
       mouse.last_MMB_state = mouse.MMB_state 
       mouse.last_Ctrl_LMB_state = mouse.Ctrl_LMB_state
       mouse.last_Ctrl_state = mouse.Ctrl_state
       mouse.last_Alt_state = mouse.Alt_state
       mouse.last_wheel = mouse.wheel   
       mouse.last_context_latch = mouse.context_latch
       mouse.last_LMB_state_TS = mouse.LMB_state_TS
       --mouse.DLMB_state = nil  
        
   end

   
       
  ---------------------------------------------------  
  function CheckUpdates(obj, conf, refresh)
  
    -- force by proj change state
      obj.SCC =  GetProjectStateChangeCount( 0 ) 
      if not obj.lastSCC then 
        refresh.GUI_onStart = true  
        refresh.data = true
       elseif obj.lastSCC and obj.lastSCC ~= obj.SCC then 
        refresh.data = true
        refresh.GUI = true
        refresh.GUI_WF = true
      end 
      obj.lastSCC = obj.SCC
      
    -- window size
      local ret = HasWindXYWHChanged(obj)
      if ret == 1 then 
        refresh.conf = true 
        refresh.data = true
        refresh.GUI_onStart = true 
        refresh.GUI_WF = true       
       elseif ret == 2 then 
        refresh.conf = true
        refresh.data = true
      end
  end
  
  ---------------------------------------------------
  function OBJ_init(obj)  
    -- globals
    obj.reapervrs = tonumber(GetAppVersion():match('[%d%.]+')) 
    obj.offs = 5 
    obj.grad_sz = 200 
    
    obj.chord_h = 60 --50 Chord Cell height
    obj.edit_h_area = 0
    obj.scroll_w = 20
    obj.scroll_val = 0
    
    -- font
    --obj.GUI_font = 'Calibri' --'chords'
    obj.GUI_fontsz = VF_CalibrateFont(21)
    obj.GUI_fontsz2 = VF_CalibrateFont( 19)
    obj.GUI_fontsz3 = VF_CalibrateFont( 15)
    obj.GUI_fontsz4 = VF_CalibrateFont( 13)
    obj.GUI_fontsz_tooltip = VF_CalibrateFont( 13)
    
    -- colors    
    obj.GUIcol = { grey =    {0.5, 0.5,  0.5 },
                   white =   {1,   1,    1   },
                   red =     {0.85,   0.35,    0.37   },
                   green =   {0.35,   0.75,    0.45   },
                   green_marker =   {0.2,   0.6,    0.2   },
                   blue =   {0.35,   0.55,    0.85   },
                   blue_marker =   {0.2,   0.5,    0.8   },
                   black =   {0,0,0 }
                   }    
    
  end
  --------------------------------------------------- 
  function OBJ_Scroll(conf, obj, data, refresh, mouse)
    local scroll_h = gfx.h - obj.edit_h_area
        obj.scroll = 
                      { clear = true,
                        x = gfx.w -obj.scroll_w -1,
                        y = 0,
                        w = obj.scroll_w,
                        h = scroll_h,
                        txt = '',
                        state = 1,
                        show = true,
                        is_but = true,
                        ignore_mouse = true,
                        alpha_back = 0.05,
                        fontsz = conf.GUI_padfontsz,--obj.GUI_fontsz2,  
                      }
        obj.scroll_handle = 
                      { clear = true,
                        x = gfx.w -obj.scroll_w -1,
                        y = obj.scroll_val * (scroll_h -obj.scroll_w)*0.5 ,
                        w = obj.scroll_w,
                        h = obj.scroll_w,
                        txt = '',
                        col = 'green',
                        show = true,
                        is_but = true,
                        alpha_back = 1.4, --0.4,
                        fontsz = conf.GUI_padfontsz,--obj.GUI_fontsz2, 
                      func =  function() 
                        mouse.context_latch_val = obj.scroll_val
                      end,
              func_LD2 = function ()
                
                          if not mouse.context_latch_val then return end
                          local dragratio = 1
                          local out_val = lim(mouse.context_latch_val + (mouse.dy/(scroll_h -obj.scroll_w))*dragratio, 0, 1)
                          if not out_val then return end
                          obj.scroll_val = out_val
                          refresh.GUI = true 
                        end,             
                         
                      }                      
  end
  ---------------------------------------------------
  function OBJ_BuildChords(conf, obj, data, refresh, mouse) 
    if not data.pr_len_measures then return end
    --local shift_x = 10
    obj.chord_area_h = gfx.h - obj.edit_h_area
    obj.chord_area_x = obj.offs
    obj.chord_area_y = obj.offs
    obj.chord_area_w = gfx.w - obj.scroll_w - obj.offs*2 
    
    obj.chord_true_h_area = obj.chord_h * ( data.pr_len_measures-1) /4
    local scroll_y_offs =  obj.scroll_val * obj.chord_true_h_area
    local last_reg_name, txt
    if data.pr_len_measures > 0 then 
      local y = obj.chord_area_y+10
      for i = 0, data.pr_len_measures do
        if y+obj.chord_h-scroll_y_offs >obj.chord_area_h then return end
        local segm = data.measures[i].cml
        local x = obj.chord_area_x + (i%4)*obj.chord_area_w /4
        obj['meas'..i..'num'] = { clear = true,
              x = x,
              y = y-scroll_y_offs+obj.chord_h,
              w = obj.chord_area_w /4,
              h = obj.chord_h,
              col = 'white',
              state = 0,
              aligh_txt = 3,
              txt= i+bar_offset, --i+1, -- count-in offset
              show = true,
              is_but = true,
              val = 0,
              fontsz = 25, --obj.GUI_fontsz4, bar measure font size
              ignore_mouse = true,
              alpha_back = 0,
              func =  function()   end}        
            
          local wsegm = math.floor(0.25*obj.chord_area_w/segm)
          for b = 0, segm-1 do
          
          obj['meas'..i..'beat'..b..'point'] = { clear = true,
                              x = x + b*wsegm,
                              y = y-scroll_y_offs + obj.chord_h*2-6,
                              w = 4,
                              h = 4,
                              --col = 'white',
                              col_int2 = data.measures[i].chord_t[b].color,
                              state = 0,
                              aligh_txt = 1,
                              txt= '',
                              show = true,
                              is_but = true,
                              val = 0,
                              fontsz = obj.GUI_fontsz,
                              alpha_back = 1,
                              ignore_mouse = true,
                              func =  function() end}  
                              
            if not data.measures[i].chord_t[b].name:find('@') then 
              local alpha_back = 0
              if data.measures[i].chord_t[b].name ~= '' then alpha_back = .3 end
              local txt0 = data.measures[i].chord_t[b].name
              
              if last_reg_name and last_reg_name:lower() == txt0:lower() then txt = '' else txt = txt0 end
              last_reg_name = txt0
              gui_width = gfx.w
              if gui_width > 1330 then gui_width = 1330 end
              if gui_width < 980 then gui_width = 980 end
              chords_width = gui_width * .05
              chords_width_rnd = round(chords_width)
              region_chrs = chord_font_size - chords_width_rnd
              --msg("Chords Width "..chords_width_rnd)
            if chord_length == 1 then  
              if string.len(last_reg_name) >= 1 and string.len(last_reg_name) <= 4 then region_chrs = 1.00 * region_chrs end
              if string.len(last_reg_name) >= 5 and string.len(last_reg_name) <= 8 then region_chrs = .75 * region_chrs end
              if string.len(last_reg_name) >= 9 and string.len(last_reg_name) <= 11 then region_chrs = .65 * region_chrs end
              if string.len(last_reg_name) >= 12 and string.len(last_reg_name) <= 16 then region_chrs = .40 * region_chrs end 
            else end  
               obj['meas'..i..'beat'..b] = { clear = true,
                    x = x + b*wsegm,
                    y = y-scroll_y_offs+obj.chord_h,
                    w = wsegm,
                    h = obj.chord_h-2,
                    --col = 'white',
                    col_int2 = data.measures[i].chord_t[b].color,
                    col_int2_a = 0.5,
                    state = 0,
                    aligh_txt = 5,
                    txt= txt,
                    txt_x_shift = 2,
                    --txt_wrap = true,
                    txt_a= 1,
                    show = true,
                    is_but = true,
                    val = 0,
                    fontsz = region_chrs, --- chord_font_size,  -- - chords_width, --region_chrs, --35,--obj.GUI_fontsz,
                    alpha_back =alpha_back,
                    --a_frame = 0.05,
                    func =  function() 
                              Undo_BeginBlock2(0)
                              Data_AddChord(conf, data, b, i)
                              Undo_EndBlock2(0, 'Add region chord', -1)
                              refresh.data=true
                              refresh.GUI = true
                            end}           
            end
          end
          obj['meas'..i] = { clear = true,
                x = x,
                y = y-scroll_y_offs+obj.chord_h,
                w = obj.chord_area_w/4,
                h = 15, --10, progress bar height
                col = 'white',
                state = 0,
                aligh_txt = 1,
                txt= '',
                show = true,
                is_but = true,
                val = 0,
                fontsz = obj.GUI_fontsz2,
                ignore_mouse = true,
                alpha_back = 0.05,
                func =  function()   end} 
          if (i%4)==3 then y = y + obj.chord_h end   
      end
    end 
  end
  ---------------------------------------------------
  function Data_AddChord(conf, data, beat, measure)
    cur_region, next_region,prev_region = {}, {}, {}
    local pos_start = TimeMap2_beatsToTime( 0,beat, measure )
    SetEditCurPos(pos_start, 1, 0)
----------------------    
    -- get current region data
      local markeridx, regionidx = GetLastMarkerAndCurRegion( 0, pos_start+0.01 )
      if regionidx >= 0 then
        cur_region  = ({EnumProjectMarkers3( 0,regionidx )})         --retval, isrgn, pos, rgnend, name, markrgnindexnumber
        --if pos_start == cur_region[3] then goto skip_cur_region end
      end  
      if not cur_region or not cur_region[1] then
        for searchmeas = measure, 0, -1 do
          for searchbeat = data.measures[measure].cml, 1, -1 do
            if searchmeas < measure or (searchmeas == measure and searchbeat < beat) then
              local searchpos = TimeMap2_beatsToTime( 0, searchbeat-1, searchmeas )
              local markeridx, regionidx = GetLastMarkerAndCurRegion( 0, searchpos+0.001 ) 
              if regionidx >=0  then
                cur_region  = ({EnumProjectMarkers3( 0,regionidx )})
                goto skip_cur_region
              end
            end
          end
        end
      end
      ::skip_cur_region::
---------------------------
  -- get prev region data
      local markeridx, regionidx = GetLastMarkerAndCurRegion( 0, pos_start+0.01 )
      if regionidx >= 0 then
        prev_region  = ({EnumProjectMarkers3(0, regionidx-1 )})         --retval, isrgn, pos, rgnend, name, markrgnindexnumber
        if prev_region and prev_region[1] then 
          goto skip_prev_region
        end
      end  
      if not prev_region or not prev_region[1] then
        for searchmeas = measure, 0, -1 do
          for searchbeat = data.measures[measure].cml, 1, -1 do
            if searchmeas < measure or (searchmeas == measure and searchbeat < beat) then
              local searchpos = TimeMap2_beatsToTime( 0, searchbeat-1, searchmeas )
              local markeridx, regionidx = GetLastMarkerAndCurRegion( 0, searchpos+0.001 ) 
              if regionidx >=0 and (cur_region and cur_region[6]) then
                prev_region  = ({EnumProjectMarkers3( 0,cur_region[6]-1 )})
                if prev_region and prev_region [1] then
                  goto skip_prev_region
                end
              end
            end
          end
        end
      end
      ::skip_prev_region::  
---------------------------      
    -- get next region data
      for searchmeas = measure, data.pr_len_measures do
        for searchbeat = 1, data.measures[measure].cml do
          if searchmeas > measure or (searchmeas == measure and searchbeat > beat) then
            local searchpos = TimeMap2_beatsToTime( 0, searchbeat-1, searchmeas )
            local markeridx, regionidx = GetLastMarkerAndCurRegion( 0, searchpos+0.001 )
            local retval, isrgn, pos, rgnend, name, markrgnindexnumber =EnumProjectMarkers3( 0,regionidx )
            if regionidx >=0 and ((cur_region and cur_region[5] and cur_region[5]:lower()~= name:lower()) or not (cur_region and cur_region[5])) then
              next_region  = ({EnumProjectMarkers3(0, regionidx )})
              goto skip_next_region
            end
          end
        end
      end 
      ::skip_next_region::
-------------------------
            
      new_color = ColorToNative(math.random(0,255),math.random(0,255),math.random(0,255))|0x1000000
      

      
      
        if skip_edit == 1 then rc_menu:show(mouse.x, mouse.y) reaper.SetEditCurPos(pos_start, 1, 0) return end
         local cur_name if cur_region and cur_region[5] then cur_name = cur_region[5] else cur_name = 'C' end
         --msg("Skip Edit "..skip_edit)
        if skip_reg ~= 1 
           then 
               commandID40 = reaper.NamedCommandLookup("_RS7c75ea4aa3a1e8fee99da50d62329c9dc6da40ae")
               reaper.Main_OnCommand(commandID40, 0)  -- Script: ReaTrak split region under cursor.lua
               
               retval, retvals_csv = GetUserInputs( conf.mb_title, 1, 'region name', cur_name) end
               
         
         if not retval then return end
         


    -- add reg
  
      if retval and retvals_csv ~= '' then
         --msg("name "..retvals_csv)
         cursor_pos = reaper.GetCursorPosition() 
         markeridx, pos_start = reaper.GetLastMarkerAndCurRegion(0, cursor_pos)
         --msg("Cursor Pos "..cursor_pos)
         retval, isrgn, pos_start, rgnend, name, markeridx, color = reaper.EnumProjectMarkers3(0, pos_start )
         reaper.SetProjectMarker3(0, markeridx, 1, pos_start, rgnend, retvals_csv, color) end
--[[               
        if (cur_region and cur_region[5] and cur_region[5] ~= retvals_csv:lower()) then
          SetProjectMarker3( 0,cur_region[6], true, cur_region[3], pos_start, cur_region[5],cur_region[7] ) -- crop previous region
          local pos_end  
          if next_region and next_region[5] then 
            if next_region[5]:lower() ~= retvals_csv:lower() then 
              pos_end = next_region[3]
              if data.chordcolorsmap[retvals_csv:lower()] then new_color = data.chordcolorsmap[retvals_csv:lower()] end
              AddProjectMarker2( 0, true, pos_start, pos_end, retvals_csv, -1, new_color )
             else
              SetProjectMarker( next_region[6], true, pos_start, next_region[4], next_region[5] )
            end
           else
            if data.chordcolorsmap[retvals_csv:lower()] then new_color = data.chordcolorsmap[retvals_csv:lower()] end
            AddProjectMarker2( 0, true, pos_start, data.pr_len, retvals_csv, -1, new_color )
          end 
         elseif not (cur_region and cur_region[5]) then 
          if next_region and next_region[5] then 
            if next_region[5]:lower() ~= retvals_csv:lower() then 
              if data.chordcolorsmap[retvals_csv:lower()] then new_color = data.chordcolorsmap[retvals_csv:lower()] end
              AddProjectMarker2( 0, true, pos_start, next_region[3], retvals_csv, -1, new_color )
             else
              SetProjectMarker( next_region[6], true, pos_start, next_region[4], next_region[5] )
            end
           else
            if data.chordcolorsmap[retvals_csv:lower()] then new_color = data.chordcolorsmap[retvals_csv:lower()] end
            AddProjectMarker2( 0, true, pos_start, data.pr_len, retvals_csv, -1, new_color )
          end 
        end
      end
--]]  
    -- remove reg WORKS
      
      if cur_region and cur_region[5] and retvals_csv == '' then
         commandID41 = reaper.NamedCommandLookup("_RS6c1d47c18a8623f9bec4db6a38f5f3244340130b")
         reaper.Main_OnCommand(commandID41, 0)  -- Script: ReaTrak merge region under cursor and the previous one.eel
      end
--[[      
      if cur_region and cur_region[5] and retvals_csv == '' then
        if next_region and next_region[3] and math.abs(cur_region[3] - pos_start) < 0.01 then
          if prev_region and prev_region [1] then 
            SetProjectMarker( prev_region[6], true, prev_region[3], cur_region[4], prev_region[5] )
            DeleteProjectMarker( 0, cur_region[6], true )
          end
        end
      end
--]]      
            
      
  end
    
  ---------------------------------------------------
  function OBJ_Update(conf, obj, data, refresh, mouse) 
    for key in pairs(obj) do if type(obj[key]) == 'table' and obj[key].clear then obj[key] = {} end end  
    
    local min_w = 300
    local min_h = 200
    local reduced_view = gfx.h  <= min_h
    gfx.w  = math.max(min_w,gfx.w)
    gfx.h  = math.max(min_h,gfx.h)
    --msg("GUI Width "..gfx.w)
    --msg("GUI Height "..gfx.h)
    OBJ_Scroll(conf, obj, data, refresh, mouse)
    OBJ_BuildChords(conf, obj, data, refresh, mouse) 
    
    
    for key in pairs(obj) do if type(obj[key]) == 'table' then 
      obj[key].context = key 
    end end    
  end


--------------------------------------------------------------------
  function main()
        conf.dev_mode = 0
        conf.vrs = vrs
        ExtState_Load(conf)
          gfx.init('MPL '..conf.mb_title..' '..conf.vrs,
                    conf.wind_w, 
                    conf.wind_h, 
                    conf.dock, conf.wind_x, conf.wind_y)
          OBJ_init(obj)
          OBJ_Update(conf, obj, data, refresh, mouse,strategy) 
          run()  
  end
--------------------------------------------------------------------  
  local ret = CheckFunctions('VF_CalibrateFont') 
  local ret2 = VF_CheckReaperVrs(5.95,true)    
  if ret and ret2 then main() end
