-- @description Snap takes to scale
-- @version 1.02
-- @author MPL
-- @changelog
--   # fix perform note selection (sorry)
-- @website http://forum.cockos.com/member.php?u=70694
-- * Modified for ReaTrak version
  
  debug = 1
  --  INIT -------------------------------------------------
  for key in pairs(reaper) do _G[key]=reaper[key]  end  
  local mouse = {}
  takes = {}
  local gui -- see GUI_define()
  local obj = {}
  local conf = {}
  sc_table = {}
  local cycle = 0
  local redraw = -1
  local SCC, lastSCC, SCC_trig
  local ProjState
  local key_names = {'C', 'C#', 'D', 'D#', 'E', 'F', 'F#', 'G', 'G#', 'A', 'A#', 'B'}
  
  ---------------------------------------------------
  local function lim(val, min,max) --local min,max 
    if not min or not max then min, max = 0,1 end 
    return math.max(min,  math.min(val, max) ) 
  end
  ---------------------------------------------------
  local function ExtState_Save()
    _, conf.wind_x, conf.wind_y, conf.wind_w, conf.wind_h = gfx.dock(-1, 0,0,0,0)
    for key in pairs(conf) do SetExtState(conf.ES_key, key, conf[key], true)  end
  end
  ---------------------------------------------------
  local function Msg(s)  ShowConsoleMsg(s..'\n') end
  function deb(s)  if debug == 1 then ShowConsoleMsg(s..'\n') end end
  ---------------------------------------------------
  local function col(col_s, a) gfx.set( table.unpack(gui.col[col_s])) if a then gfx.a = a end  end
  ---------------------------------------------------
  local function GUI_DrawBut(o) 
    if not o then return end
    local x,y,w,h, txt = o.x, o.y, o.w, o.h, o.txt
    if not x or not y or not w or not h then return end
    gfx.a = o.alpha_back or 0.3
    gfx.blit( 2, 1, 0, -- grad back
              0,0,  obj.grad_sz,obj.grad_sz,
              x,y,w,h, 0,0)
    col(o.col, o.alpha_back or 0.2)
    gfx.rect(x,y,w,h,1)
    if o.txt then 
      col('white', o.alpha_txt or 0.8)
      gfx.setfont(1, gui.font, gui.fontsz)
      gfx.x = x+ (w-gfx.measurestr(txt))/2
      gfx.y = y+ (h-gfx.texth)/2
      if o.bot_al_txt then 
        gfx.y = y+ h-gfx.texth-3
      end
      gfx.drawstr(o.txt)
    end
    if o.rect_a then 
      col(o.col, o.alpha_back or 0.2)
      gfx.rect(x,y,w,h,0)
    end
  end
  ---------------------------------------------------
  function  GUI_scale()  
    local pat_t = GetPattern(conf.scale_root, conf.scale_pat)
    
    local cnt_wt = 0 
    local cnt_not_wt = 0
    local t ,alpha_txt
    local w_n = math.floor(obj.pat.w/7)
    for i = 1, 12 do
      local alpha_txt
      if ({Check_Scale(i-1, pat_t)})[2] then alpha_txt = 0.9 else alpha_txt = 0.2 end
      --msg(alpha_txt)
      if      i == 1
          or  i == 3 
          or  i == 5 
          or  i == 6 
          or  i == 8 
          or  i == 10 
          or  i == 12 then 
          
          cnt_wt = cnt_wt + 1
          GUI_DrawBut(
                          {x = math.ceil((cnt_wt-1) * w_n),
                          y = obj.item_h*2,
                          w = w_n,
                          h = obj.pat.h,
                          col = 'white',
                          alpha_back = 0.09, --default 0.09
                          --rect_a = 0.3,
                          alpha_txt=alpha_txt,
                          state = 0,
                          is_but = true,
                          bot_al_txt = true,
                          txt = key_names[i]}
                      )
          gfx.a = 0.2
          local add_y_sub
          if i == 6 then add_y_sub = obj.pat.h/1.5 else  add_y_sub = 0 end
          gfx.line(math.ceil((cnt_wt-1) * w_n), 
                    obj.item_h*2+obj.pat.h,
                   math.ceil((cnt_wt-1) * w_n),
                    obj.item_h*2+obj.pat.h/1.5 -add_y_sub)
       else
          cnt_not_wt = cnt_not_wt + 1 
          if i == 7 then cnt_not_wt = cnt_not_wt + 1  end
          GUI_DrawBut(
                          {x = math.floor((cnt_not_wt - 0.5) * obj.pat.w/7),
                          y = obj.item_h*2,
                          w = math.floor(obj.pat.w/7),
                          h = obj.pat.h/1.5,
                          col = 'white',
                          alpha_back = 0.2, --default 0.2
                          --rect_a = 0.3,
                          state = 0,
                          is_but = true,
                          bot_al_txt = true,
                          txt = key_names[i]}
                      )
          if i == 2 or i == 7 or i == 9  then 
            gfx.a = 0.2
            gfx.line(math.floor((cnt_not_wt+0.5) * obj.pat.w/7), 
                      obj.item_h*2,
                     math.floor((cnt_not_wt+0.5 ) * obj.pat.w/7),
                      obj.item_h*2+obj.pat.h/1.5 ) 
          end                     
        
      end
    end
  end
  
  ---------------------------------------------------
  local function GUI_draw()
    gfx.mode = 0
    -- redraw: -1 init, 1 maj changes, 2 minor changes
    -- 1 back
    -- 2 gradient
    --// 3 dynamic stuff
      
    --  init
      if redraw == -1 then
        OBJ_Update()
        gfx.dest = 2
        gfx.setimgdim(2, -1, -1)  
        gfx.setimgdim(2, obj.grad_sz,obj.grad_sz)  
        local r,g,b,a = 0.9,0.9,1,0.6
        gfx.x, gfx.y = 0,0
        local c = 0.6
        local drdx = c*0.00001
        local drdy = c*0.00001
        local dgdx = c*0.00008
        local dgdy = c*0.0001    
        local dbdx = c*0.00008
        local dbdy = c*0.00001
        local dadx = c*0.00003
        local dady = c*0.0004       
        gfx.gradrect(0,0, obj.grad_sz,obj.grad_sz, 
                        r,g,b,a, 
                        drdx, dgdx, dbdx, dadx, 
                        drdy, dgdy, dbdy, dady) 
        redraw = 1 -- force com redraw after init 
      end
      
    -- refresh
      if redraw == 1 then 
        OBJ_Update()
        -- refresh backgroung
          gfx.dest = 1
          gfx.setimgdim(1, -1, -1)  
          gfx.setimgdim(1, gfx.w, gfx.h) 
          gfx.blit( 2, 1, 0, -- grad back
                    0,0,  obj.grad_sz,obj.grad_sz,
                    0,0,  gfx.w,gfx.h, 0,0)
          gfx.a = 0.1
          --gfx.line(gfx.w-obj.menu_w, 0,gfx.w-obj.menu_w, gfx.h )
        -- refresh all buttons
          for key in pairs(obj) do
            if not key:match('knob') and type(obj[key]) == 'table' and obj[key].is_but then
              GUI_DrawBut(obj[key])
            end
          end 
          GUI_scale()         
      end
      
      
    --  render    
      gfx.dest = -1   
      gfx.a = 1
      gfx.x,gfx.y = 0,0
    --  back
      gfx.blit(1, 1, 0, -- backgr
          0,0,gfx.w, gfx.h,
          0,0,gfx.w, gfx.h, 0,0)  
    
    
    redraw = 0
    gfx.update()
  end
  ---------------------------------------------------
  function HasWindXYWHChanged()
    local  _, wx,wy,ww,wh = gfx.dock(-1, 0,0,0,0)
    local retval=0
    if wx ~= obj.last_gfxx or wy ~= obj.last_gfxy then retval= 2 end --- minor
    if ww ~= obj.last_gfxw or wh ~= obj.last_gfxh then retval= 1 end --- major
    if not obj.last_gfxx then retval = -1 end
    obj.last_gfxx, obj.last_gfxy, obj.last_gfxw, obj.last_gfxh = wx,wy,ww,wh
    return retval
  end
  ---------------------------------------------------
  local function ExtState_Def()
    return {ES_key = 'MPL_SnapSelTakesToScale',
            wind_x =  50,
            wind_y =  50,
            wind_w =  200,
            wind_h =  350,
            dock =    0,
            scale_root = 0,
            scale_pat = '101011010101',
            scale_name = 'Default (whole tone)'}
  end
  ---------------------------------------------------
  local function ExtState_Load()
    local def = ExtState_Def()
    for key in pairs(def) do 
      local es_str = GetExtState(def.ES_key, key)
      if es_str == '' then conf[key] = def[key] else conf[key] = tonumber(es_str) or es_str end
    end
  end
  ---------------------------------------------------
  function GetTakes()
    takes = {}
    for i = 1, CountSelectedMediaItems(0) do
      local it = GetSelectedMediaItem( 0, i-1 )
      local tk =  GetActiveTake( it )
      if tk and TakeIsMIDI(tk) then 
        takes[#takes+1] =  {guid = BR_GetMediaItemTakeGUID( tk ),
                            data =  ({MIDI_GetAllEvts( tk, '' )})[2]}
      end
    end
  end
  ---------------------------------------------------
  local function OBJ_define()  
    obj.offs = 2
    obj.grad_sz = 200
    obj.item_h = math.floor(gfx.h/7)
    
    obj.get = { x = 0,
                y = 0,
                h = obj.item_h,
                txt = "Get takes",
                col = 'white',
                state = 0,
                is_but = true,
                alpha_back = 0.2,
                func =  function() GetTakes()end}
    obj.cur_root = {x = 0,
                y = obj.item_h,
                h = obj.item_h,
                col = 'white',
                state = 0,
                is_but = true,
                alpha_back = 0.08,
                func =  function() Menu_Root()end}
    obj.cur_scale = {x = 0,
                y = obj.item_h,
                h = obj.item_h,
                col = 'white',
                state = 0,
                is_but = true,
                alpha_back = 0.08,
                func =  function() Menu_Scale() end} 
    obj.pat =  {x = 0,
                y = obj.item_h*2,
                h = obj.item_h*4,
                col = 'white',
                alpha_back = 0.09,
                state = 0
                }               
    obj.set = { x = 0,
                y = obj.item_h*6,
                h = obj.item_h*.5,
                txt = "Snap takes",
                col = 'white',
                state = 0,
                is_but = true,
                alpha_back = 0.2,
                func =  function() SetTakes()end}
    obj.no = { x = 0,
                y = obj.item_h*6,
                h = obj.item_h*1.5,
                txt = "Remove item Scale name",
                col = 'white',
                state = 0,
                is_but = true,
                alpha_back = 0.2,
                func =  function() NoScaleName()end}                               
                      
                      
  end
  ---------------------------------------------------
  function NoScaleName() --Remove the Scale name prefix from item
    itemM = reaper.GetSelectedMediaItem(0,0) -- Get selected item 
  
    takeM = reaper.GetMediaItemTake(itemM, 0)
  
  
  -- GET TAKE NAME
    takename = reaper.GetTakeName(takeM)
  
    if string.match(takename, ".*Scale ", 1, true) 
  
    then newtakename = string.gsub(takename, ".*Scale ", "") 
    else newtakename = takename end      
  
    retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String(takeM, "P_NAME", newtakename, 1)
 end
  
  
  function SetTakes()
    pat  = GetPattern(conf.scale_root, conf.scale_pat)
    for i = 1, #takes do
      local take = GetMediaItemTakeByGUID( 0, takes[i].guid )
      if take then 
        MIDI_SetAllEvts( take,  takes[i].data )
        local _, notecnt = MIDI_CountEvts( take )
        for i = 1, notecnt do
          local _, selected, muted, startppqpos, endppqpos, chan, pitch, vel = reaper.MIDI_GetNote( take, i-1 )
          --new_pitch = pitch % 12
          new_pitch = Check_Scale(pitch, pat)
          MIDI_SetNote( take, i-1, true, muted, startppqpos, endppqpos, chan, new_pitch, vel, true )
        end
        reaper.MIDI_Sort( take )
      end
    end
    UpdateArrange()
    
    --Msg("Scale name "..name_scale)
    --Msg("Root note "..name_root)
    itemM = reaper.GetSelectedMediaItem(0,0) -- Get selected item 
   
    takeM = reaper.GetMediaItemTake(itemM, 0)


    -- GET TAKE NAME
    takename = reaper.GetTakeName(takeM)
    --Msg("Take name "..takename)
    if string.match(takename, ".*Scale ", 1, true) 
   
    then newtakename = string.gsub(takename, ".*Scale ", "") 
    else newtakename = takename end      
    
    space = " "
    
    retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String(takeM, "P_NAME", name_root..space..name_scale.." Scale "..newtakename, 1)
    --Msg("New take name "..newtakename)
     
  end
  ---------------------------------------------------
  function OBJ_Update()
    obj.get.w = gfx.w
    obj.set.w = gfx.w
    obj.no.w = gfx.w
    local scale_x_offs = 0.35
    obj.cur_root.w = math.floor(gfx.w*scale_x_offs)
    obj.cur_scale.x = math.floor(gfx.w*scale_x_offs)
    obj.cur_scale.w = gfx.w - math.floor(gfx.w*scale_x_offs)
    obj.cur_root.txt = "KeyRoot: "..key_names[tonumber(conf.scale_root)+1]
    obj.cur_scale.txt = "Scale: "..conf.scale_name
    obj.pat.w = gfx.w
    obj.pat.scale = conf.scale_pat

  end
  ---------------------------------------------------
  function Menu(t)
    gfx.x = mouse.mx
    gfx.y = mouse.my
    local ret = gfx.showmenu('')
  end
  ---------------------------------------------------
  function Menu_Root()
    gfx.x = mouse.mx
    gfx.y = mouse.my
    local ret = gfx.showmenu(table.concat(key_names, '|'))
    if ret > 0 then conf.scale_root = ret - 1 ExtState_Save() redraw = 1 SetTakes() end
  end
  ---------------------------------------------------
  function Menu_Scale()
    gfx.x = mouse.mx
    gfx.y = mouse.my
    local str = 'Default||'
    for i = 1, #sc_table do
      str = str..sc_table[i].name..'|'
    end
    local ret = gfx.showmenu(str)
    if ret and ret > 0 then 
      if ret > 1 and ret < #sc_table+2 then 
        conf.scale_pat = sc_table[ret-1].pat 
        conf.scale_name = sc_table[ret-1].name 
       else
        conf.scale_pat = ({ExtState_Def()})[1].scale_pat
        conf.scale_name = ({ExtState_Def()})[1].scale_name 
      end
      ExtState_Save() 
      redraw = 1 
      SetTakes()
    end
  end
  
 ---------------------------------------------------
  local function MOUSE_Match(b) if b.x and b.y and b.w and b.h then return mouse.mx > b.x and mouse.mx < b.x+b.w and mouse.my > b.y and mouse.my < b.y+b.h end  end
 ------------- -------------------------------------- 
  local function MOUSE_Click(b) return MOUSE_Match(b) and mouse.LMB_state and not mouse.last_LMB_state end
  local function MOUSE_ClickR(b) return MOUSE_Match(b) and mouse.RMB_state and not mouse.last_RMB_state end
  ---------------------------------------------------
  local function MOUSE()
    mouse.mx = gfx.mouse_x
    mouse.my = gfx.mouse_y
    mouse.LMB_state = gfx.mouse_cap&1 == 1 
    mouse.RMB_state = gfx.mouse_cap&2 == 2 
    mouse.MMB_state = gfx.mouse_cap&64 == 64
    mouse.LMB_state_doubleclick = false
    mouse.Ctrl_LMB_state = gfx.mouse_cap&5 == 5 
    mouse.Ctrl_state = gfx.mouse_cap&4 == 4 
    mouse.Alt_state = gfx.mouse_cap&17 == 17 -- alt + LB
    mouse.wheel = gfx.mouse_wheel
    if mouse.last_wheel then mouse.wheel_trig = (mouse.wheel - mouse.last_wheel) end 
    if mouse.LMB_state and not mouse.last_LMB_state then  mouse.last_mx_onclick = mouse.mx     mouse.last_my_onclick = mouse.my end    
    if mouse.last_mx_onclick and mouse.last_my_onclick then mouse.dx = mouse.mx - mouse.last_mx_onclick  mouse.dy = mouse.my - mouse.last_my_onclick else mouse.dx, mouse.dy = 0,0 end

    -- butts    
    for key in pairs(obj) do
      if not key:match('knob') and type(obj[key]) == 'table'and obj[key].is_but then
        if MOUSE_Click(obj[key]) then obj[key].func() end
      end
    end
          
    
    -- mouse release    
      if mouse.last_LMB_state and not mouse.LMB_state   then  mouse.context_latch = '' end
      mouse.last_LMB_state = mouse.LMB_state  
      mouse.last_RMB_state = mouse.RMB_state
      mouse.last_MMB_state = mouse.MMB_state 
      mouse.last_Ctrl_LMB_state = mouse.Ctrl_LMB_state
      mouse.last_Ctrl_state = mouse.Ctrl_state
      mouse.last_Alt_state = mouse.Alt_state
      mouse.last_wheel = mouse.wheel      
  end
  ---------------------------------------------------
  function run()
    SCC =  GetProjectStateChangeCount( 0 ) 
    if not lastSCC or lastSCC ~= SCC then SCC_trig = true else SCC_trig = false end lastSCC = SCC
    clock = os.clock()
    cycle = cycle+1
    local st_wind = HasWindXYWHChanged()
    if st_wind >= -1 then ExtState_Save() if math.abs(st_wind) == 1 then redraw = st_wind  end end
    if SCC_trig then redraw = -1 end
    MOUSE()
    GUI_draw()
    if gfx.getchar() >= 0 then defer(run) else atexit(gfx.quit) end
  end
  ---------------------------------------------------
  local function GUI_define()
    gui = {
                aa = 1,
                mode = 3,
                fontname = 'Calibri',
                fontsz = 16,
                col = { grey =    {0.5, 0.5,  0.5 },
                        white =   {1,   1,    1   },
                        red =     {1,   0,    0   },
                        green =   {0.3,   0.9,    0.3   }
                      }
                
                }
    
      if OS == "OSX32" or OS == "OSX64" then gui.fontsize = gui.fontsize - 7 end
  end
  ---------------------------------------------------
--"Major" 101011010101
  function LoadScale()
    local content = [[
// Scales use same synthax as .reascale files
"Major" 101011010101
"Dorian" 102304050670
"Phrygian" 120304056070
"Lydian" 102030450607
"Mixolydian" 102034050670
"Minor" 102304056070
"Locrian" 120304506070
"Harmonic Minor" 102304056007
"Harmonic Major" 102034056007
"Medolic Minor"  102304050607
"Hungarian Gypsy 1" 102300456007
"Hungarian Gypsy 2" 102300456070
"Hungarian Major" 100230450670
"Enigmatic" 120030405067
"Persian" 120034506007
"Composite Blues" 100334450070 ]]  
    local scales_path = ({get_action_context()})[2]:match('(.*).lua')..'_scales.txt'
    local f = io.open(scales_path, 'r')
    if not f then 
      f = io.open(scales_path, 'w')
      f:write(content)
      f:close()
     else
      local content = f:read('a')
      f:close()
    end
    sc_table  ={}
    for line in content:gmatch('[^\r\n]+') do
      local pat = line:match('%d%d%d%d%d%d%d%d%d%d%d%d')
      local name = line:match('"(.*)"')
      if pat and name then sc_table[#sc_table+1] = {pat =pat ,name=name } end
    end
  end
  -----------------------------------------  
  function GetPattern(root, scale)
    local pat,ex = {}
    local scale = tostring(scale)
    scale = scale:match('%d%d%d%d%d%d%d%d%d%d%d%d')
    scale = scale:sub(12-root+1)..scale:sub(0, 12-root)
    for num in scale:gmatch('%d') do 
      pat[#pat+1] = tonumber(num)>0 
      if tonumber(num) then ex = true end -- check if at least one note in pattern
    end
    --Msg(root)
    --Msg(scale)
         if scale == "101011010101" or scale == "110101101010" or scale == "011010110101" or scale == "101101011010"
            or scale == "010110101101" or scale == "101011010110" or scale == "010101101011" or scale == "101010110101"
            or scale == "110101011010" or scale == "011010101101" or scale == "101101010110" or scale == "010110101011" then name_scale = "Major" 
         elseif scale == "102304050670" or scale == "010230405067" or scale == "701023040506" or scale == "670102304050"
            or scale == "067010230405" or scale == "506701023040" or scale == "050670102304" or scale == "405067010230"
            or scale == "040506701023" or scale == "304050670102" or scale == "230405067010" or scale == "023040506701" then name_scale = "Dorian" 
         elseif scale == "120304056070" or scale == "012030405607" or scale == "701203040560" or scale == "070120304056"
            or scale == "607012030405" or scale == "560701203040" or scale == "056070120304" or scale == "405607012030"
            or scale == "040560701203" or scale == "304056070120" or scale == "030405607012" or scale == "203040560701" then name_scale = "Phrygian" 
         elseif scale == "102030450607" or scale == "710203045060" or scale == "071020304506" or scale == "607102030450"
            or scale == "060710203045" or scale == "506071020304" or scale == "450607102030" or scale == "045060710203"
            or scale == "304506071020" or scale == "030450607102" or scale == "203045060710" or scale == "020304506071" then name_scale = "Lydian"  
         elseif scale == "102034050670" or scale == "010203405067" or scale == "701020340506" or scale == "670102034050"
            or scale == "067010203405" or scale == "506701020340" or scale == "050670102034" or scale == "405067010203"
            or scale == "340506701020" or scale == "034050670102" or scale == "203405067010" or scale == "020340506701" then name_scale = "Mixolydian" 
         elseif scale == "102304056070" or scale == "010230405607" or scale == "701023040560" or scale == "070102304056"
            or scale == "607010230405" or scale == "560701023040" or scale == "056070102304" or scale == "405607010230"
            or scale == "040560701023" or scale == "304056070102" or scale == "230405607010" or scale == "023040560701" then name_scale = "Minor" 
         elseif scale == "120304506070" or scale == "012030450607" or scale == "701203045060" or scale == "070120304506"
            or scale == "607012030450" or scale == "060701203045" or scale == "506070120304" or scale == "450607012030"
            or scale == "045060701203" or scale == "304506070120" or scale == "030450607012" or scale == "203045060701" then name_scale = "Locrian" 
         elseif scale == "102304056007" or scale == "710230405600" or scale == "071023040560" or scale == "007102304056"
            or scale == "600710230405" or scale == "560071023040" or scale == "056007102304" or scale == "405600710230"
            or scale == "040560071023" or scale == "304056007102" or scale == "230405600710" or scale == "023040560071" then name_scale = "Harmonic Minor" 
         elseif scale == "102034056007" or scale == "710203405600" or scale == "071020340560" or scale == "007102034056"
            or scale == "600710203405" or scale == "560071020340" or scale == "056007102034" or scale == "405600710203"
            or scale == "340560071020" or scale == "034056007102" or scale == "203405600710" or scale == "020340560071" then name_scale = "Harmonic Major" 
         elseif scale == "102304050607" or scale == "710230405060" or scale == "071023040506" or scale == "607102304050"
            or scale == "060710230405" or scale == "506071023040" or scale == "050607102304" or scale == "405060710230"
            or scale == "040506071023" or scale == "304050607102" or scale == "230405060710" or scale == "023040506071" then name_scale = "Medolic Minor"  
         elseif scale == "102300456007" or scale == "710230045600" or scale == "071023004560" or scale == "007102300456"
            or scale == "600710230045" or scale == "560071023004" or scale == "456007102300" or scale == "045600710230"
            or scale == "004560071023" or scale == "300456007102" or scale == "230045600710" or scale == "023004560071" then name_scale = "Hungarian Gypsy 1" 
         elseif scale == "102300456070" or scale == "010230045607" or scale == "701023004560" or scale == "070102300456"
            or scale == "607010230045" or scale == "560701023004" or scale == "456070102300" or scale == "045607010230"
            or scale == "004560701023" or scale == "300456070102" or scale == "230045607010" or scale == "023004560701" then name_scale = "Hungarian Gypsy 2" 
         elseif scale == "100230450670" or scale == "010023045067" or scale == "701002304506" or scale == "670100230450"
            or scale == "067010023045" or scale == "506701002304" or scale == "450670100230" or scale == "045067010023"
            or scale == "304506701002" or scale == "230450670100" or scale == "023045067010" or scale == "002304506701" then name_scale = "Hungarian Major" 
         elseif scale == "120030405067" or scale == "712003040506" or scale == "671200304050" or scale == "067120030405"
            or scale == "506712003040" or scale == "050671200304" or scale == "405067120030" or scale == "040506712003"
            or scale == "304050671200" or scale == "030405067120" or scale == "003040506712" or scale == "200304050671" then name_scale = "Enigmatic" 
         elseif scale == "120034506007" or scale == "712003450600" or scale == "071200345060" or scale == "007120034506"
            or scale == "600712003450" or scale == "060071200345" or scale == "506007120034" or scale == "450600712003"
            or scale == "345060071200" or scale == "034506007120" or scale == "003450600712" or scale == "200345060071" then name_scale = "Persian" 
         elseif scale == "100334450070" or scale == "010033445007" or scale == "701003344500" or scale == "070100334450"
            or scale == "007010033445" or scale == "500701003344" or scale == "450070100334" or scale == "445007010033"
            or scale == "344500701003" or scale == "334450070100" or scale == "033445007010" or scale == "003344500701" then name_scale = "Composite Blues"
         else name_scale = "" end 
         
         if root == 0 then name_root = "C"
         elseif root == 1 then name_root = "C#"
         elseif root == 2 then name_root = "D"
         elseif root == 3 then name_root = "D#"
         elseif root == 4 then name_root = "E"
         elseif root == 5 then name_root = "F"
         elseif root == 6 then name_root = "F#"
         elseif root == 7 then name_root = "G"
         elseif root == 8 then name_root = "G#"
         elseif root == 9 then name_root = "A"
         elseif root == 10 then name_root = "A#"
         elseif root == 11 then name_root = "B"
         else name_root = "" end
--Msg("Root "..root)
--Msg("Scale "..scale)
--Msg("Root note 1 "..name_root)
--Msg("Scale name 1 "..name_scale)                  
                                                                                                   
     
    if ex then return pat end
  end
  -----------------------------------------
  function Check_Scale(pitch, pat)
    local note = pitch % 12 +1
    local q_note
    for i = 1, 12 do
      if pat[i] then q_note = i end
      if pat[i] and i == note then return pitch, true end
      if not pat[i] and i == note and q_note then return pitch - (i-q_note),false end
    end
    return pitch,false
  end
  ---------------------------------------------------
  LoadScale()
  ExtState_Load()  
  gfx.init('ReaTrak - MPL Snap takes to scale',conf.wind_w, conf.wind_h, conf.dock, conf.wind_x, conf.wind_y)
  OBJ_define()
  OBJ_Update()
  GUI_define()
  GetTakes()
  run()
  
  
