-----DEBUG CONTROL--------------------------------------------------------------

debug_output = true -- true/false --display debug messages in the console

-----DISPLAY CONSOLE MESSAGE----------------------------------------------------

-- Display a message in the console for debugging, message can be a number variable
-- or a string but not mixed. No line feed character is added.
function Msg(value)
  --returns nothing

  if debug_output then --check if flag is set true (at the start of this script)
    reaper.ShowConsoleMsg(tostring(value) )
  end
end


local dm, _ = debug_mode
local function Msg(str)
  reaper.ShowConsoleMsg(tostring(str).."\n")
end

local function next_region()   
       commandID2 = reaper.NamedCommandLookup("_SWS_SELNEXTMORR")
       reaper.Main_OnCommand(commandID2, 0) --SWS: Goto/select next marker/region
       time = reaper.GetCursorPosition()
       markrgnindexnumber, rgnendOut = reaper.GetLastMarkerAndCurRegion(0, time)
       retval, isrgnOut, posOut, rgnendOut, nameOut, markrgnindexnumberOut = reaper.EnumProjectMarkers(rgnendOut)
       start_time, end_time = reaper.GetSet_LoopTimeRange(true, true, posOut, rgnendOut, 0)
       if string.match( nameOut, "@.*") then next_region() end -- skip region marked @ ignore 
       end  



   
    commandID1 = reaper.NamedCommandLookup("_RS36f146bbf2f5b41d41315020d307f6b50c4ccbac")
    reaper.Main_OnCommand(commandID1, 0) --Script: ReaTrak move cursor to time selection.lua   


    time = reaper.GetCursorPosition()
    markrgnindexnumber, rgnendOut = reaper.GetLastMarkerAndCurRegion(0, time)
    retval, isrgnOut, posOut, rgnendOut, nameOut, markrgnindexnumberOut = reaper.EnumProjectMarkers(rgnendOut)
    start_time, end_time = reaper.GetSet_LoopTimeRange(true, true, posOut, rgnendOut, 0)
    --clear_name_flag = 0 --this flag is needed in the SetProjectMarker4 function to enable the region name to be cleared
    --reaper.SetProjectMarker4(0, markrgnindexnumberOut, true, posOut, rgnendOut, chord, 0, clear_name_flag)
    
    
    if string.match( nameOut, "@.*") then next_region() end -- skip region marked @ ignore
    chordroot, chordtype = string.match(nameOut, "(%w[#b]?)(.*)$")
    if not chordtype or #chordtype == 0 then chordtype = "Maj" end

    if chordroot == "C" then rootkey = 0 end
    if chordroot == "C#" then rootkey = 1 end
    if chordroot == "Db" then rootkey = 1 end
    if chordroot == "D" then rootkey = 2 end
    if chordroot == "D#" then rootkey = 3 end
    if chordroot == "Eb" then rootkey = 3 end
    if chordroot == "E" then rootkey = 4 end
    if chordroot == "F" then rootkey = 5 end
    if chordroot == "F#" then rootkey = 6 end
    if chordroot == "Gb" then rootkey = 6 end
    if chordroot == "G" then rootkey = 7 end
    if chordroot == "G#" then rootkey = 8 end
    if chordroot == "Ab" then rootkey = 8 end
    if chordroot == "A" then rootkey = 9 end
    if chordroot == "A#" then rootkey = 10 end
    if chordroot == "Bb" then rootkey = 10 end
    if chordroot == "B" then rootkey = 11 end



if string.find(",Maj,M,", ","..chordtype..",", 1, true) then notenums = "0,4,7" end              
if string.find(",m,min,", ","..chordtype..",", 1, true) then notenums = "0,3,7" end            
if string.find(",dim,m-5,mb5,m(b5),0,", ","..chordtype..",", 1, true) then notenums = "0,3,6" end                
if string.find(",aug,+,+5,(#5),", ","..chordtype..",", 1, true) then notenums = "0,4,8" end                
if string.find(",-5,(b5),", ","..chordtype..",", 1, true) then notenums = "0,4,6" end                
if string.find(",sus2,", ","..chordtype..",", 1, true) then notenums = "0,2,7" end                
if string.find(",sus4,sus,(sus4),", ","..chordtype..",", 1, true) then notenums = "0,5,7" end                
if string.find(",5,", ","..chordtype..",", 1, true) then notenums = "0,7,12" end                  
if string.find(",5add7,5/7,", ","..chordtype..",", 1, true) then notenums = "0,7,10,12" end               
if string.find(",add2,(add2),", ","..chordtype..",", 1, true) then notenums = "0,2,4,7" end              
if string.find(",add4,(add4),", ","..chordtype..",", 1, true) then notenums = "0,4,5,7" end              
if string.find(",madd4,m(add4),", ","..chordtype..",", 1, true) then notenums = "0,3,5,7" end              
if string.find(",11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,17" end       
if string.find(",11sus4,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,14,17" end       
if string.find(",m11,min11,-11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,14,17" end       
if string.find(",Maj11,maj11,M11,Maj7(add11),M7(add11),", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,14,17" end       
if string.find(",mMaj11,minmaj11,mM11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,11,14,17" end       
if string.find(",aug11,9+11,9aug11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,18" end       
if string.find(",augm11, m9#11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,14,18" end       
if string.find(",11b5,11-5,11(b5),", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,14,17" end       
if string.find(",11#5,11+5,11(#5),", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,14,17" end       
if string.find(",11b9,11-9,11(b9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,13,17" end       
if string.find(",11#9,11+9,11(#9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15,17" end       
if string.find(",11b5b9,11-5-9,11(b5b9),", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,13,17" end       
if string.find(",11#5b9,11+5-9,11(#5b9),", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,13,17" end       
if string.find(",11b5#9,11-5+9,11(b5#9),", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,15,17" end       
if string.find(",11#5#9,11+5+9,11(#5#9),", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,15,17" end       
if string.find(",m11b5,m11-5,m11(b5),", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,14,17" end       
if string.find(",m11#5,m11+5,m11(#5),", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,14,17" end       
if string.find(",m11b9,m11-9,m11(b9),", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,13,17" end       
if string.find(",m11#9,m11+9,m11(#9),", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,15,17" end       
if string.find(",m11b5b9,m11-5-9,m11(b5b9),", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,13,17" end       
if string.find(",m11#5b9,m11+5-9,m11(#5b9),", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,13,17" end       
if string.find(",m11b5#9,m11-5+9,m11(b5#9),", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,15,17" end       
if string.find(",m11#5#9,m11+5+9,m11(#5#9),", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,15,17" end       
if string.find(",Maj11b5,maj11b5,maj11-5,maj11(b5),", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,14,17" end       
if string.find(",Maj11#5,maj11#5,maj11+5,maj11(#5),", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,14,17" end       
if string.find(",Maj11b9,maj11b9,maj11-9,maj11(b9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,13,17" end       
if string.find(",Maj11#9,maj11#9,maj11+9,maj11(#9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,15,17" end       
if string.find(",Maj11b5b9,maj11b5b9,maj11-5-9,maj11(b5b9),", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,13,17" end       
if string.find(",Maj11#5b9,maj11#5b9,maj11+5-9,maj11(#5b9),", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,13,17" end       
if string.find(",Maj11b5#9,maj11b5#9,maj11-5+9,maj11(b5#9),", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,15,17" end       
if string.find(",Maj11#5#9,maj11#5#9,maj11+5+9,maj11(#5#9),", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,15,17" end       
if string.find(",13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,17,21" end    
if string.find(",m13,min13,-13,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,14,17,21" end    
if string.find(",Maj13,maj13,M13,Maj7(add13),M7(add13),min,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,14,17,21" end    
if string.find(",mMaj13,minmaj13,mM13,", ","..chordtype..",", 1, true) then notenums = "0,3,7,11,14,17,21" end    
if string.find(",13b5,13-5,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,14,17,21" end    
if string.find(",13#5,13+5,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,14,17,21" end    
if string.find(",13b9,13-9,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,13,17,21" end    
if string.find(",13#9,13+9,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15,17,21" end    
if string.find(",13b5b9,13-5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,13,17,21" end    
if string.find(",13#5b9,13+5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,13,17,21" end    
if string.find(",13b5#9,13-5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,15,17,21" end    
if string.find(",13#5#9,13+5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,15,17,21" end    
if string.find(",13b9#11,13-9+11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,13,18,21" end    
if string.find(",m13b5,m13-5,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,14,17,21" end    
if string.find(",m13#5,m13+5,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,14,17,21" end    
if string.find(",m13b9,m13-9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,13,17,21" end    
if string.find(",m13#9,m13+9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,15,17,21" end    
if string.find(",m13b5b9,m13-5-9,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,13,17,21" end    
if string.find(",m13#5b9,m13+5-9,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,13,17,21" end    
if string.find(",m13b5#9,m13-5+9,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,15,17,21" end    
if string.find(",m13#5#9,m13+5+9,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,15,17,21" end    
if string.find(",Maj13b5,maj13b5,maj13-5,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,14,17,21" end    
if string.find(",Maj13#5,maj13#5,maj13+5,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,14,17,21" end    
if string.find(",Maj13b9,maj13b9,maj13-9,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,13,17,21" end    
if string.find(",Maj13#9,maj13#9,maj13+9,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,15,17,21" end    
if string.find(",Maj13b5b9,maj13b5b9,maj13-5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,13,17,21" end    
if string.find(",Maj13#5b9,maj13#5b9,maj13+5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,13,17,21" end    
if string.find(",Maj13b5#9,maj13b5#9,maj13-5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,15,17,21" end    
if string.find(",Maj13#5#9,maj13#5#9,maj13+5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,15,17,21" end    
if string.find(",Maj13#11,maj13#11,maj13+11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,14,18,21" end    
if string.find(",13#11,13+11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,18,21" end    
if string.find(",m13#11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,14,18,21" end    
if string.find(",13sus4,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,14,17,21" end    
if string.find(",6,M6,Maj6,maj6,", ","..chordtype..",", 1, true) then notenums = "0,4,7,9" end              
if string.find(",m6,min6,", ","..chordtype..",", 1, true) then notenums = "0,3,7,9" end              
if string.find(",6add4,6/4,6(add4),Maj6(add4),M6(add4),", ","..chordtype..",", 1, true) then notenums = "0,4,5,7,9" end            
if string.find(",m6add4,m6/4,m6(add4),", ","..chordtype..",", 1, true) then notenums = "0,3,5,7,9" end            
if string.find(",69,6add9,6/9,6(add9),Maj6(add9),M6(add9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,9,14" end           
if string.find(",m6add9,m6/9,m6(add9),", ","..chordtype..",", 1, true) then notenums = "0,3,7,9,14" end           
if string.find(",6sus2,", ","..chordtype..",", 1, true) then notenums = "0,2,7,9" end              
if string.find(",6sus4,", ","..chordtype..",", 1, true) then notenums = "0,5,7,9" end              
if string.find(",6add11,6/11,6(add11),Maj6(add11),M6(add11),", ","..chordtype..",", 1, true) then notenums = "0,4,7,9,17" end           
if string.find(",m6add11,m6/11,m6(add11),m6(add11),", ","..chordtype..",", 1, true) then notenums = "0,3,7,9,17" end           
if string.find(",7,dom,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10" end             
if string.find(",7add2,", ","..chordtype..",", 1, true) then notenums = "0,2,4,7,10" end           
if string.find(",7add4,", ","..chordtype..",", 1, true) then notenums = "0,4,5,7,10" end           
if string.find(",m7,min7,-7,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10" end             
if string.find(",m7add4,", ","..chordtype..",", 1, true) then notenums = "0,3,5,7,10" end           
if string.find(",Maj7,maj7,Maj7,M7,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11" end             
if string.find(",dim7,07,", ","..chordtype..",", 1, true) then notenums = "0,3,6,9" end              
if string.find(",mMaj7,minmaj7,mmaj7,min/maj7,mM7,m(addM7),m(+7),-(M7),", ","..chordtype..",", 1, true) then notenums = "0,3,7,11" end             
if string.find(",7sus2,", ","..chordtype..",", 1, true) then notenums = "0,2,7,10" end             
if string.find(",7sus4,7sus,7sus11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10" end             
if string.find(",Maj7sus2,maj7sus2,M7sus2,", ","..chordtype..",", 1, true) then notenums = "0,2,7,11" end             
if string.find(",Maj7sus4,maj7sus4,M7sus4,", ","..chordtype..",", 1, true) then notenums = "0,5,7,11" end             
if string.find(",aug7,+7,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10" end             
if string.find(",7b5,7-5,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10" end             
if string.find(",7#5,7+5,7+,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10" end             
if string.find(",m7b5,m7-5,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10" end             
if string.find(",m7#5,m7+5,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10" end             
if string.find(",Maj7b5,maj7b5,maj7-5,M7b5,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11" end             
if string.find(",Maj7#5,maj7#5,maj7+5,M7+5,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11" end             
if string.find(",7b9,7-9,7(addb9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,13" end          
if string.find(",7#9,7+9,7(add#9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15" end          
if string.find(",m7b9, m7-9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,13" end          
if string.find(",m7#9, m7+9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,15" end          
if string.find(",Maj7b9,maj7b9,maj7-9,maj7(addb9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,13" end          
if string.find(",Maj7#9,maj7#9,maj7+9,maj7(add#9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,15" end          
if string.find(",7b9b13,7-9-13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,13,20" end       
if string.find(",m7b9b13, m7-9-13,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,13,20" end       
if string.find(",7b13,7-13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,20" end       
if string.find(",m7b13,m7-13,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,14,20" end       
if string.find(",7#9b13,7+9-13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15,20" end       
if string.find(",m7#9b13,m7+9-13,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,15,20" end       
if string.find(",7b5b9,7-5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,13" end          
if string.find(",7b5#9,7-5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,15" end          
if string.find(",7#5b9,7+5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,13" end          
if string.find(",7#5#9,7+5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,15" end          
if string.find(",7#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,18" end          
if string.find(",7add6,7/6,", ","..chordtype..",", 1, true) then notenums = "0,4,7,9,10" end           
if string.find(",7add11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,17" end          
if string.find(",7add13,7/13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,21" end          
if string.find(",m7add11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,17" end          
if string.find(",m7b5b9,m7-5-9,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,13" end          
if string.find(",m7b5#9,m7-5+9,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,15" end          
if string.find(",m7#5b9,m7+5-9,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,13" end          
if string.find(",m7#5#9,m7+5+9,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,15" end          
if string.find(",m7#11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,18" end          
if string.find(",Maj7b5b9,maj7b5b9,maj7-5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,13" end          
if string.find(",Maj7b5#9,maj7b5#9,maj7-5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,15" end          
if string.find(",Maj7#5b9,maj7#5b9,maj7+5-9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,13" end          
if string.find(",Maj7#5#9,maj7#5#9,maj7+5+9,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,15" end          
if string.find(",Maj7add11,maj7add11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,17" end          
if string.find(",Maj7#11,maj7#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,18" end          
if string.find(",9,7(add9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14" end          
if string.find(",m9,min9,-9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,10,14" end          
if string.find(",Maj9,maj9,M9,Maj7(add9),M7(add9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,14" end          
if string.find(",Maj9sus4,maj9sus4,", ","..chordtype..",", 1, true) then notenums = "0,5,7,11,14" end          
if string.find(",mMaj9,minmaj9,mmaj9,min/maj9,mM9,m(addM9),m(+9),-(M9),", ","..chordtype..",", 1, true) then notenums = "0,3,7,11,14" end          
if string.find(",9sus4,9sus,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,14" end          
if string.find(",aug9,+9,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15" end          
if string.find(",9add6,9/6,", ","..chordtype..",", 1, true) then notenums = "0,4,7,9,10,14" end        
if string.find(",m9add6,m9/6,", ","..chordtype..",", 1, true) then notenums = "0,3,7,9,14" end           
if string.find(",9b5,9-5,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,14" end          
if string.find(",9#5,9+5,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,14" end          
if string.find(",m9b5,m9-5,", ","..chordtype..",", 1, true) then notenums = "0,3,6,10,14" end          
if string.find(",m9#5,m9+5,", ","..chordtype..",", 1, true) then notenums = "0,3,8,10,14" end          
if string.find(",Maj9b5,maj9b5,", ","..chordtype..",", 1, true) then notenums = "0,4,6,11,14" end          
if string.find(",Maj9#5,maj9#5,", ","..chordtype..",", 1, true) then notenums = "0,4,8,11,14" end          
if string.find(",Maj9#11,maj9#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,11,14,18" end       
if string.find(",b9#11,-9+11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,13,18" end       
if string.find(",add9,2,", ","..chordtype..",", 1, true) then notenums = "0,4,7,14" end             
if string.find(",madd9,m(add9),-(add9),", ","..chordtype..",", 1, true) then notenums = "0,3,7,14" end             
if string.find(",add11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,17" end             
if string.find(",madd11,m(add11),-(add11),", ","..chordtype..",", 1, true) then notenums = "0,3,7,17" end             
if string.find(",(b9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,13" end             
if string.find(",(#9),", ","..chordtype..",", 1, true) then notenums = "0,4,7,15" end             
if string.find(",(b5b9),", ","..chordtype..",", 1, true) then notenums = "0,4,6,13" end             
if string.find(",(#5b9),", ","..chordtype..",", 1, true) then notenums = "0,4,8,13" end             
if string.find(",(b5#9),", ","..chordtype..",", 1, true) then notenums = "0,4,6,15" end             
if string.find(",(#5#9),", ","..chordtype..",", 1, true) then notenums = "0,4,8,15" end             
if string.find(",m(b9), mb9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,13" end             
if string.find(",m(#9), m#9,", ","..chordtype..",", 1, true) then notenums = "0,3,7,15" end             
if string.find(",m(b5b9), mb5b9,", ","..chordtype..",", 1, true) then notenums = "0,3,6,13" end             
if string.find(",m(#5b9), m#5b9,", ","..chordtype..",", 1, true) then notenums = "0,3,8,13" end             
if string.find(",m(b5#9), mb5#9,", ","..chordtype..",", 1, true) then notenums = "0,3,6,15" end             
if string.find(",m(#5#9), m#5#9,", ","..chordtype..",", 1, true) then notenums = "0,3,8,15" end             
if string.find(",m(#11), m#11,", ","..chordtype..",", 1, true) then notenums = "0,3,7,18" end             
if string.find(",(#11),", ","..chordtype..",", 1, true) then notenums = "0,4,7,18" end             
if string.find(",m#5,", ","..chordtype..",", 1, true) then notenums = "0,3,8" end                
if string.find(",maug,augaddm3,augadd(m3),", ","..chordtype..",", 1, true) then notenums = "0,3,8,10" end                  
if string.find(",13#9#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15,18,21" end    
if string.find(",13#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,18,21" end    
if string.find(",13susb5,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,14,17,21" end    
if string.find(",13susb5#9,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,15,21" end       
if string.find(",13susb5b9,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,13,17,21" end    
if string.find(",13susb9,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,13,17,21" end    
if string.find(",13susb9#11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,13,18,21" end    
if string.find(",13sus#5,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,17,21" end       
if string.find(",13sus#5b9,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,13,17,21" end    
if string.find(",13sus#5b9#11,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,13,18,21" end    
if string.find(",13sus#5#11,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,18" end          
if string.find(",13sus#5#9#11,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,15,18" end       
if string.find(",13sus#9,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,15,17,21" end    
if string.find(",13sus#9#11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,15,18,21" end    
if string.find(",13sus#11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,14,18,21" end    
if string.find(",7b5b13,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,20" end              
if string.find(",7b5#9b13,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,15,20" end       
if string.find(",7#5#11,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,18" end          
if string.find(",7#5#9#11,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,15,18" end       
if string.find(",7#5b9#11,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,13,18" end       
if string.find(",7#9#11b13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,15,18,20" end       
if string.find(",7#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10, 18" end             
if string.find(",7#11b13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,18,20" end       
if string.find(",7susb5,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10" end             
if string.find(",7susb5b9,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,13" end          
if string.find(",7b5b9b13,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,13,20" end       
if string.find(",7susb5b13,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,14,20" end       
if string.find(",7susb5#9,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,15" end          
if string.find(",7susb5#9b13,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,15,20" end       
if string.find(",7susb9,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,13" end          
if string.find(",7susb9b13,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,13,20" end       
if string.find(",7susb9#11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,13,18" end       
if string.find(",7susb9#11b13,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,13,18,20" end    
if string.find(",7susb13,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,20" end          
if string.find(",7sus#5,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10" end             
if string.find(",7sus#5#9#11,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,15,18" end       
if string.find(",7sus#5#11,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,18" end          
if string.find(",7sus#9,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,15" end          
if string.find(",7sus#9b13,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,15,20" end       
if string.find(",7sus#9#11b13,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,15,18,20" end    
if string.find(",7sus#11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,18" end          
if string.find(",7sus#11b13,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,18,20" end       
if string.find(",9b5b13,", ","..chordtype..",", 1, true) then notenums = "0,4,6,10,14,20" end       
if string.find(",9b13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,20" end       
if string.find(",9#5#11,", ","..chordtype..",", 1, true) then notenums = "0,4,8,10,14,18" end       
if string.find(",9#11,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,18" end       
if string.find(",9#11b13,", ","..chordtype..",", 1, true) then notenums = "0,4,7,10,14,18,20" end    
if string.find(",9susb5,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,14" end    
if string.find(",9susb5b13,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,14,20" end    
if string.find(",9sus#11,", ","..chordtype..",", 1, true) then notenums = "0,5,7,10,18" end          
if string.find(",9susb5#9,", ","..chordtype..",", 1, true) then notenums = "0,5,6,10,14,15" end       
if string.find(",9sus#5#11,", ","..chordtype..",", 1, true) then notenums = "0,5,8,10,14,18" end
if string.find(",quartal,", ","..chordtype..",", 1, true) then notenums = "0,5,10,15" end
if string.find(",sowhat,", ","..chordtype..",", 1, true) then notenums = "0,5,10,16" end
             
                 
--Msg("Chord Type: "..chordtype)
--Msg("Note Numbers: "..notenums)



--Convert Chord to Reascale

x1=1
x2=0
x3=0
x4=0
x5=0
x6=0
x7=0
x8=0
x9=0
x10=0
x11=0
x12=0




--Cnotes = {0, 4, 7, 10}
local str = (notenums)
local t = {}
for num in string.gmatch(str, "%d+") do
    t[#t+1] = tonumber(num)
end


Cnotes = t

  if Cnotes[2] == 1 then x2=2
  elseif Cnotes[2] == 2 then x3=2
  elseif Cnotes[2] == 3 then x4=3
  elseif Cnotes[2] == 4 then x5=3
  elseif Cnotes[2] == 5 then x6=4
  elseif Cnotes[2] == 6 then x7=5
  elseif Cnotes[2] == 7 then x8=5
  elseif Cnotes[2] == 8 then x9=5
  elseif Cnotes[2] == 9 then x10=6
  elseif Cnotes[2] == 10 then x11=7
  elseif Cnotes[2] == 11 then x12=7
  elseif Cnotes[2] == 13 then x2=9
  elseif Cnotes[2] == 14 then x3=9
  elseif Cnotes[2] == 15 then x4=9
  elseif Cnotes[2] == 16 then x5=9
  elseif Cnotes[2] == 17 then x6="B"
  elseif Cnotes[2] == 18 then x7="B"

  end
  
  if Cnotes[3] == 3 then x4=3 
  elseif Cnotes[3] == 4 then x5=3
  elseif Cnotes[3] == 5 then x6=4
  elseif Cnotes[3] == 6 then x7=5
  elseif Cnotes[3] == 7 then x8=5
  elseif Cnotes[3] == 8 then x9=5  
  elseif Cnotes[3] == 9 then x10=6
  elseif Cnotes[3] == 10 then x11=7
  elseif Cnotes[3] == 11 then x12=7
  elseif Cnotes[3] == 13 then x2=9
  elseif Cnotes[3] == 14 then x3=9
  elseif Cnotes[3] == 15 then x4=9
  elseif Cnotes[3] == 16 then x5=9
  elseif Cnotes[3] == 17 then x6="B"
  elseif Cnotes[3] == 18 then x7="B"

  end
  
  if Cnotes[4] == 5 then x6=4
  elseif Cnotes[4] == 6 then x7=5
  elseif Cnotes[4] == 7 then x8=5
  elseif Cnotes[4] == 8 then x9=5
  elseif Cnotes[4] == 9 then x10=6
  elseif Cnotes[4] == 10 then x11=7
  elseif Cnotes[4] == 11 then x12=7
  elseif Cnotes[4] == 13 then x2=9
  elseif Cnotes[4] == 14 then x3=9
  elseif Cnotes[4] == 15 then x4=9
  elseif Cnotes[4] == 16 then x5=9
  elseif Cnotes[4] == 17 then x6="B"
  elseif Cnotes[4] == 18 then x7="B"  
  elseif Cnotes[4] == 19 then x8="B"
  elseif Cnotes[4] == 20 then x9="B"
  elseif Cnotes[4] == 21 then x10="D"
  elseif Cnotes[4] == 22 then x11="D"
  elseif Cnotes[4] == 23 then x12="D"
   
  end  


  if Cnotes[5] == 6 then x7=5 
  elseif Cnotes[5] == 7 then x8=5
  elseif Cnotes[5] == 8 then x9=5
  elseif Cnotes[5] == 9 then x10=6
  elseif Cnotes[5] == 10 then x11=7
  elseif Cnotes[5] == 11 then x12=7
  elseif Cnotes[5] == 13 then x2=9
  elseif Cnotes[5] == 14 then x3=9
  elseif Cnotes[5] == 15 then x4=9
  elseif Cnotes[5] == 16 then x5=9
  elseif Cnotes[5] == 17 then x6="B"
  elseif Cnotes[5] == 18 then x7="B"
  elseif Cnotes[5] == 19 then x8="B"
  elseif Cnotes[5] == 20 then x9="B"
  elseif Cnotes[5] == 21 then x10="D"
  elseif Cnotes[5] == 22 then x11="D"
  elseif Cnotes[5] == 23 then x12="D"
  
  end  


  
  if Cnotes[6] == 7 then x8=6
  elseif Cnotes[6] == 8 then x9=6
  elseif Cnotes[6] == 9 then x10=6
  elseif Cnotes[6] == 10 then x11=7
  elseif Cnotes[6] == 11 then x12=7
  elseif Cnotes[6] == 13 then x2=9
  elseif Cnotes[6] == 14 then x3=9
  elseif Cnotes[6] == 15 then x4=9
  elseif Cnotes[6] == 16 then x5=9
  elseif Cnotes[6] == 17 then x6="B"
  elseif Cnotes[6] == 18 then x7="B"
  elseif Cnotes[6] == 19 then x8="B"
  elseif Cnotes[6] == 20 then x9="B"
  elseif Cnotes[6] == 21 then x10="D"
  elseif Cnotes[6] == 22 then x11="D"
  elseif Cnotes[6] == 23 then x12="D"
  
  end   


  if Cnotes[7] == 7 then x8=7
  elseif Cnotes[7] == 8 then x9=7
  elseif Cnotes[7] == 9 then x10=7
  elseif Cnotes[7] == 10 then x11=7
  elseif Cnotes[7] == 11 then x12=7
  elseif Cnotes[7] == 13 then x2=9
  elseif Cnotes[7] == 14 then x3=9
  elseif Cnotes[7] == 15 then x4=9
  elseif Cnotes[7] == 16 then x5=9
  elseif Cnotes[7] == 17 then x6="B"
  elseif Cnotes[7] == 18 then x7="B"
  elseif Cnotes[7] == 19 then x8="B"
  elseif Cnotes[7] == 20 then x9="B"
  elseif Cnotes[7] == 21 then x10="D"
  elseif Cnotes[7] == 22 then x11="D"
  elseif Cnotes[7] == 23 then x12="D"
  
  end   


reascale = (x1 .. x2 .. x3 .. x4 .. x5 .. x6 .. x7 .. x8 .. x9 .. x10 .. x11 .. x12)




              

if Cnotes[3] == nil then Cnotes[3] = 0 end
if Cnotes[4] == nil then Cnotes[4] = 0 end
if Cnotes[5] == nil then Cnotes[5] = 0 end
if Cnotes[6] == nil then Cnotes[6] = 0 end
if Cnotes[7] == nil then Cnotes[7] = 0 end

--Msg("Region: " .. nameOut)
--Msg("Chord Root: " .. chordroot)
--Msg("Chord Type: " .. chordtype)
--Msg("notenums: " .. notenums)
--Msg("Reascale: " .. reascale)


reaper.Main_OnCommand(40718, 0) --Item: Select all items on selected tracks in current time selection


reaper.Main_OnCommand(40153, 0) --Item: Open in built-in MIDI editor (set default behavior in preferences)

--commandID1 = reaper.NamedCommandLookup("_SN_FOCUS_MIDI_EDITOR")
--reaper.Main_OnCommand(commandID1, 0) --SWS/SN: Focus MIDI editor
hwnd = reaper.MIDIEditor_GetActive()
reaper.MIDIEditor_OnCommand( hwnd, 40877 ) --Edit: Select all notes starting in time selection

-- @version 1.01
-- @description Snap selected notes to scale
-- @author MPL
-- @website http://forum.cockos.com/member.php?u=70694

  for key in pairs(reaper) do _G[key]=reaper[key]  end 
  function GetPattern(root, scale)
    local pat,ex = {}
    for num in scale:gmatch('%w') do
    if num == "A" then num = "10" end
    if num == "B" then num = "11" end
    if num == "C" then num = "12" end
    if num == "D" then num = "13" end
    if num == "E" then num = "14" end
    Msg("num: " .. num)      
      pat[#pat+1] = num+root>0 
      if num+root>0 then ex = true end -- check if at least one note in pattern
    end
    if ex then return pat end
  end
  -----------------------------------------
  function Check_Scale(pitch, pat)
    local note = pitch % 12 +1
    --Msg(note)
    local q_note
    for i = 1, 12 do
      if pat[i] then q_note = i end
      if pat[i] and i == note then return pitch end
      if not pat[i] and i == note then return pitch - (i-q_note) end
    end
    --Msg(q_note)
    return pitch
  end
  -----------------------------------------
  function main()   
    local ME = MIDIEditor_GetActive()
    if not ME then return end
    local take = MIDIEditor_GetTake(ME)
    if not take or not TakeIsMIDI(take) then return end
    --if MIDIEditor_GetSetting_int( ME, 'scale_enabled' )==0 then return end
    local root = "0" --MIDIEditor_GetSetting_int( ME, 'scale_root' )
    Msg(root)
    local scale= reascale --({MIDIEditor_GetSetting_str( ME, 'scale', '' )})[2]
    Msg(scale)
    local pat  = GetPattern(root, scale)
    if not pat then return end
    local _, notecnt = reaper.MIDI_CountEvts( take )
    keychange = 0
    for i = 1, notecnt do
      local _, selected, muted, startppqpos, endppqpos, chan, pitch, vel = reaper.MIDI_GetNote( take, i-1 )
      --new_pitch = pitch % 12
      new_pitch = Check_Scale(pitch, pat)
      --Msg(new_pitch)
      if selected then reaper.MIDI_SetNote( take, i-1, true, muted, startppqpos, endppqpos, chan, new_pitch + rootkey, vel, true ) end
    end
    reaper.MIDI_Sort( take )
  end
  
  
  -----------------------------------------  
  reaper.Undo_BeginBlock()
  main()
  reaper.Undo_EndBlock('Snap midi to chord', 0)
  reaper.MIDIEditor_OnCommand( hwnd, 2 ) --File: Close window
  commandID2 = reaper.NamedCommandLookup("_SWS_SELNEXTMORR")
  reaper.Main_OnCommand(commandID2, 0) --SWS: Goto/select next marker/region  
   
   
